package analysisOperations;

import ij.ImageStack;
import imagejProxies.SilentAnalyzer;


public class MeasureAllSlicesOperation extends MeasureOperation {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public void doIt() {
		measurements = null;
		result = this.getCopyOfOrReferenceTo(this.getInputImage(), inputImage.getTitle() + " - measure all slices");
		measurements = this.getMeasurements();
		measurements.reset();
		this.processSlices();
	}
	
	protected void doItForSlice(int sliceNumber, ImageStack stack) {
		SilentAnalyzer analyzer = new SilentAnalyzer(this.getInputImage(), 
				 this.getMeasurementsWord(), 
				 measurements);
		this.getInputImage().setSlice(sliceNumber);
		analyzer.setup("", this.getInputImage());
		analyzer.run(this.getInputImage().getProcessor());
	}
	
	/**
	 * 
	 */
	protected void showResult() {
		this.getMeasurements().show("measurements on " + this.getInputImage().getTitle());
	}
}
