/*
 * Created on 17.08.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package analysisOperations;

import java.awt.Point;

import nj.Dijkstra;
import ij.ImagePlus;
import ij.ImageStack;
import ij.gui.NewImage;
import ij.measure.ResultsTable;
import operations.Operation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ShortestPathsOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = 625126369337009255L;
	protected HessianImage hessianImage;
	protected ResultsTable points;
	protected ImagePlus resultStack;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		// Set parameterTypes, parameterNames and resultType
		parameterTypes = new Class[2];
		parameterTypes[0] = Class.forName("analysisOperations.HessianImage");
		parameterTypes[1] = Class.forName("ij.measure.ResultsTable");
		parameterNames = new String[2];
		parameterNames[0] = "HessianImage";
		parameterNames[1] = "Points";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultNames = new String[1];
		resultNames[0] = "ResultStack";
	}
	
	public void doIt() {
		 Dijkstra dijkstra = new Dijkstra();
		 ImageStack stack = new ImageStack(hessianImage.getHessian()[0][0].length, 
		 								   hessianImage.getHessian()[0].length);
		 for (int i=0; i<points.getCounter(); i++) {
		 	ImagePlus result = NewImage.createByteImage("costs", hessianImage.getHessian()[0][0].length, hessianImage.getHessian()[0].length, 1, NewImage.GRAY8);
		 	float x = points.getValue(ResultsTable.X_CENTROID, i);
		 	float y = points.getValue(ResultsTable.Y_CENTROID, i);
		 	Point p = new Point(Math.round(x),Math.round(y));
		 	byte[][] dirs = dijkstra.run(hessianImage.getHessian(), p);
		 	for (int xIndex = 0; xIndex < dirs[0].length; xIndex++) {
				for (int yIndex = 0; yIndex < dirs.length; yIndex++) {
					// result.getProcessor().putPixel(xIndex, yIndex, 10 * (int)Math.round(dirs[yIndex][xIndex]));
					int value = (int)Math.round(dirs[yIndex][xIndex]);
					if (value==4 || value==5 || value == 0) {
						value = 1;
					} else {
						value = 0;
					}
					int cost = (int)Math.round(hessianImage.getHessian()[0][yIndex][xIndex]);
					cost = 254 - cost;
					result.getProcessor().putPixel(xIndex, yIndex, cost*value);
					
				}
			}
		 	stack.addSlice("dirs " + (new Integer(i)).toString(), result.getProcessor());
		 }
		 if (points.getCounter()>0) {
		 	resultStack = new ImagePlus("dirs", stack);
		 } else {
		 	resultStack = new ImagePlus();
		 }
	}
	
	/**
	 * @return Returns the inputImage.
	 */
	public HessianImage getHessianImage() {
		return hessianImage;
	}
	/**
	 * @param inputImage The inputImage to set.
	 */
	public void setHessianImage(HessianImage hessianImage) {
		this.hessianImage = hessianImage;
	}
	/**
	 * @return Returns the points.
	 */
	public ResultsTable getPoints() {
		return points;
	}
	/**
	 * @param points The points to set.
	 */
	public void setPoints(ResultsTable points) {
		this.points = points;
	}
	/**
	 * @return Returns the resultStack.
	 */
	public ImagePlus getResultStack() {
		return resultStack;
	}
	/**
	 * @param resultStack The resultStack to set.
	 */
	public void setResultStack(ImagePlus resultStack) {
		this.resultStack = resultStack;
	}
	
	/**
	 * 
	 */
	protected void cleanUpInput() {
		this.setHessianImage(null);
		this.setPoints(null);
	}
}
