/*
 * Created on 26.01.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package analysisOperations;

import java.awt.Color;
import java.awt.Font;

import ij.ImagePlus;
import ij.ImageStack;
import ij.measure.ResultsTable;
import gui.Option;
import operations.Operation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SplitAndCountOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = 573964876472704428L;
	Option averageSize;
	ResultsTable measurements;
	ResultsTable count;
	protected float[] areas;
	protected double averageArea;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		optionsNames = new String[1];
		optionsNames[0] = "average size";
		parameterTypes = new Class[2];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterTypes[1] = Class.forName("ij.measure.ResultsTable");
		parameterNames = new String[2];
		parameterNames[0] = "InputImage";
		parameterNames[1] = "Measurements";
		resultTypes = new Class[2];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultTypes[1] = Class.forName("ij.measure.ResultsTable");
		resultNames = new String[2];
		resultNames[0] = "Result";
		resultNames[1] = "Count";
	}
	/**
	 * @return Returns the averageSize.
	 */
	public double getAverageSize() {
		return averageSize.getDoubleValue();
	}
	/**
	 * @param averageSize The averageSize to set.
	 */
	public void setAverageSize(double averageSize) {
		this.averageSize.setValue(Double.toString(averageSize));
	}
	
	public void connectOptions() {
		this.averageSize = (Option) this.options.getOptions().elementAt(0);
	}
	
	protected void setupOptions() {
		super.setupOptions();
		this.setAverageSize(0);
	}
	
	public void doIt() {
		ImagePlus inputImage = this.getInputImage();
		result = this.getCopyOfOrReferenceTo(inputImage, inputImage.getTitle());
		this.setupAreasAndAverage();
		this.processSlices();
	}
	
	protected void doItForSlice(int sliceNumber, ImageStack stack) {
		ResultsTable measurements = this.getMeasurements();
		count = new ResultsTable();
		int newCount = 0;
		for (int i=0; i<measurements.getCounter(); i++) {
			float area = areas[i];
			int objectCount = Math.max((int)Math.floor(area / (averageArea * 1.0)), 1);
			newCount += objectCount;
			this.markObject(i, objectCount);
		}
		count.setHeading(1,"count");
		count.incrementCounter();
		count.addValue(1, newCount);
	}
	
	/**
	 * @param i
	 */
	private void markObject(int i, int objectCount) {
		int x = Math.round(this.getMeasurements().getColumn(ResultsTable.X_CENTROID)[i]);
		int y = Math.round(this.getMeasurements().getColumn(ResultsTable.Y_CENTROID)[i]);
		result.getProcessor().setColor(Color.green);
		result.getProcessor().setFont(new Font("SansSerif", Font.PLAIN, 48));
		result.getProcessor().drawString(Integer.toString(objectCount), x, y);
		result.getProcessor().setColor(Color.black);
	}
	/**
	 * @param measurements2
	 * @return
	 */
	protected void setupAreasAndAverage() {
		areas = this.getMeasurements().getColumn(ResultsTable.AREA);
		if (this.getAverageSize()==0) {
			averageArea = 0;
			for (int i=0; i<areas.length; i++) {
				averageArea += areas[i];
			}
			averageArea /= (areas.length * 1.0);
		} else {
			averageArea = this.getAverageSize();
		}
	}
	/**
	 * @return Returns the measurements.
	 */
	public ResultsTable getMeasurements() {
		return measurements;
	}
	/**
	 * @param measurements The measurements to set.
	 */
	public void setMeasurements(ResultsTable measurements) {
		this.measurements = measurements;
	}
	
	protected void cleanUpInput() {
		super.cleanUpInput();
		this.setMeasurements(null);
	}
	/**
	 * @return Returns the count.
	 */
	public ResultsTable getCount() {
		return count;
	}
	/**
	 * @param count The count to set.
	 */
	public void setCount(ResultsTable count) {
		this.count = count;
	}
}
