/*
 * Created on 21.07.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package applications;

import java.awt.Point;
import java.util.Vector;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.JPanel;
import operations.Operation;
import operations.OperationView;
import java.awt.Toolkit;
/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
/**
 * Example of components laid out in a grid
 */
public class ApplicationView extends javax.swing.JFrame {
	private javax.swing.JPanel ivjJFrameContentPane = null;
	private JScrollPane jScrollPane = null;
	private JPanel jPanel = null;
	protected Application model;
	
	public ApplicationView(Application model) {
		super();
		this.model = model;
		initialize();
	}

	/**
	 * Return the JFrameContentPane property value.
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJFrameContentPane() {
		if (ivjJFrameContentPane == null) {
			ivjJFrameContentPane = new javax.swing.JPanel();
			ivjJFrameContentPane.setName("JFrameContentPane");
			ivjJFrameContentPane.setLayout(new BoxLayout(ivjJFrameContentPane, BoxLayout.Y_AXIS));
			ivjJFrameContentPane.setPreferredSize(new java.awt.Dimension(19,19));
			ivjJFrameContentPane.add(getJScrollPane(), null);
		}
		return ivjJFrameContentPane;
	}

	/**
	 * Initialize the class.
	 */
	private void initialize() {

		this.setIconImage(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/icon.gif")));
		this.setName("JFrame1");
		this
				.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		this.setBounds(45, 25, 317, 273);
		this.setTitle(model.name());
		this.setContentPane(getJFrameContentPane());
		this.addWindowListener(new java.awt.event.WindowAdapter() {   
			public void windowActivated(java.awt.event.WindowEvent e) {    
				model.moveToFront((ApplicationView)getJPanel().getTopLevelAncestor());
			} 
			public void windowClosing(java.awt.event.WindowEvent e) {
				model.applicationViewClosed((ApplicationView)getJPanel().getTopLevelAncestor());
				dispose();
			}
		});
		Vector operations = model.getOperations();
		double xSize = 0;
		double ySize = 0;
		int maxButtonWidth = 0;
		int buttonWidth;
		for (int i=0; i<operations.size(); i++) {
			Operation anOperation = (Operation) operations.elementAt(i);
			OperationView view = anOperation.view();
			buttonWidth = view.getJButton1().getText().length();
			if (buttonWidth > maxButtonWidth) maxButtonWidth = buttonWidth;
			if (anOperation.getParameterNames()!=null && anOperation.getParameterNames().length>0) {
				view.getParameterButton().setEnabled(true);
			}
			getJPanel().add(view.getJPanel());
			if (view.getSize().getWidth()>xSize) xSize = view.getSize().getWidth();
			ySize += view.getSize().getHeight()+1;
		}
		for (int i=0; i<operations.size(); i++) {
			Operation anOperation = (Operation) operations.elementAt(i);
			OperationView view = anOperation.view();
			JButton button = view.getJButton1(); 
			String text = button.getText();
			if (text.length()<maxButtonWidth) {
				while(text.length()<maxButtonWidth) {
					text += " ";
				}
			}
			button.setText(text);
		}
		this.setSize((int)xSize+16, Math.min((int)ySize, 600));
		if (model.getOperations().size()==0) {
			this.setSize(200, 400);
		}
	}
	
	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */    
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJPanel());
		}
		return jScrollPane;
	}
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	public JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setLayout(new BoxLayout(jPanel, BoxLayout.Y_AXIS));
		}
		return jPanel;
	}
	/**
	 * @return Returns the model.
	 */
	public Application getModel() {
		return model;
	}

	/**
	 * @param operation
	 * @param localPoint
	 */
	public void operationDropedAt(Operation operation, Point localPoint) {
		Vector operations = model.getOperations();
		int addAfterIndex = -1;
		for (int i=0; i<operations.size(); i++) {
			Operation op = (Operation) operations.elementAt(i);
			Point opOrigin = new Point(op.view().getJPanel().getX(), op.view().getJPanel().getY());
			if (localPoint.getY()>opOrigin.getY()) {
				addAfterIndex = i;
			}
		}
		if (operation.view().isInOperationsBox()) return;
		if (operations.contains(operation)) return;
		model.addOperationAfterIndex(operation, addAfterIndex);
	}

	/**
	 * 
	 */
	public void rebuild() {
		this.initialize();
		
	}

	/**
	 * @param model2
	 */
	public void removeOperation(Operation operation) {
		jPanel.remove(operation.view().getJPanel());
		model.removeOperation(operation);
	}
  }
