/*
 * Created on 25.10.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package broadcaster;

import ij.gui.ImageWindow;
import ij.gui.StackWindow;

import java.awt.KeyboardFocusManager;
import java.awt.Window;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Observable;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class WindowManagerBroadcaster extends Observable implements PropertyChangeListener, WindowListener { 
	static WindowManagerBroadcaster instance = null;
	
	public WindowManagerBroadcaster() {
		super();
		this.initialize();
	}
	
	/**
	 * 
	 */
	protected void initialize() {
		 KeyboardFocusManager.getCurrentKeyboardFocusManager().addPropertyChangeListener("activeWindow", this); 
	}

	/**
	 * @param string
	 */
	public void changed(String anAspect) {
		this.setChanged();
		this.notifyObservers(anAspect);
		this.clearChanged();
	}

	public static WindowManagerBroadcaster getInstance() {
		if (instance == null) {
			instance = new WindowManagerBroadcaster();
		}
		return instance;
	}

	/* (non-Javadoc)
	 * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
	 */
	public void propertyChange(PropertyChangeEvent event) {
		if (event.getPropertyName()!="activeWindow") return;
		Window newWin = (Window)event.getNewValue();
		if (newWin==null) return;
		if (newWin.getClass()==ImageWindow.class || newWin.getClass()==StackWindow.class) {
//			this.changed("currentImage");
			newWin.addWindowListener(this); 
		}
	}

	/* (non-Javadoc)
	 * @see java.awt.event.WindowListener#windowOpened(java.awt.event.WindowEvent)
	 */
	public void windowOpened(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see java.awt.event.WindowListener#windowClosing(java.awt.event.WindowEvent)
	 */
	public void windowClosing(WindowEvent arg0) {
	}

	/* (non-Javadoc)
	 * @see java.awt.event.WindowListener#windowClosed(java.awt.event.WindowEvent)
	 */
	public void windowClosed(WindowEvent event) {
		event.getWindow().removeWindowListener(this);
	}

	/* (non-Javadoc)
	 * @see java.awt.event.WindowListener#windowIconified(java.awt.event.WindowEvent)
	 */
	public void windowIconified(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see java.awt.event.WindowListener#windowDeiconified(java.awt.event.WindowEvent)
	 */
	public void windowDeiconified(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see java.awt.event.WindowListener#windowActivated(java.awt.event.WindowEvent)
	 */
	public void windowActivated(WindowEvent event) {
		Window newWin = (Window)event.getWindow();
		if (newWin==null) return;
		if (newWin.getClass()==ImageWindow.class || newWin.getClass()==StackWindow.class) {
			this.changed("currentImage");
		}
	}

	/* (non-Javadoc)
	 * @see java.awt.event.WindowListener#windowDeactivated(java.awt.event.WindowEvent)
	 */
	public void windowDeactivated(WindowEvent event) {
		event.getWindow().removeWindowListener(this);
		
	}
}
