package controlOperations;

import operations.Operation;

public class GetImageNameOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected String imageName;
	
	public GetImageNameOperation() {
		super();
	}
	
	protected void initialize() throws ClassNotFoundException {	
		super.initialize();
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("java.lang.String");
		resultNames = new String[1];
		resultNames[0] = "ImageName";
	}

	public void doIt() {
		this.setImageName(this.getInputImage().getOriginalFileInfo().directory + this.getInputImage().getOriginalFileInfo().fileName);
	}
	
	public String getImageName() {
		return imageName;
	}

	public void setImageName(String imageName) {
		this.imageName = imageName;
	}
}
