package controlOperations;

import gui.Option;
import operations.Operation;

public class NTimesRepeatOperation extends Operation {

	private Option n;
	protected Boolean atEnd = new Boolean(false);
	protected int counter;
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	public int getN() {
		return n.getIntegerValue();
	}
	
	public void setN(int n) {
		this.n.setValue(Integer.toString(n));
	}

	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[0];
		parameterNames = new String[0];
		optionsNames = new String[1];
		optionsNames[0] = "number of repetitions";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("controlOperations.NTimesRepeatOperation");
		resultNames = new String[1];
		resultNames[0] = "NTimesRepeatOperation";
	}

	public NTimesRepeatOperation getNTimesRepeatOperation() {
		return this;
	}
	
	public void setNTimesRepeatOperation(NTimesRepeatOperation op) {
		// noop
	}
	
	public Boolean getAtEnd() {
		return atEnd;
	}

	public void setAtEnd(Boolean atEnd) {
		this.atEnd = atEnd;
	}
	
	public void doIt() {
		counter += 1;
		if (counter==this.getN()) {
			this.setAtEnd(new Boolean(true));
			counter = 0;
		}
	}
	
	protected void setupOptions() {
		super.setupOptions();
		this.setN(2);
		n.setMin(1);
		n.setShortHelpText("the number of times to repeat the body of the loop");
	}
	
	public void connectOptions() {
		this.n = (Option) this.options.getOptions().elementAt(0);
	}
	
	/**
	 * @return
	 */
	public boolean isLoop() {
		return true;
	}
}
