/*
 * Created on 21.06.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package fileOperations;

import java.io.File;
import java.util.Vector;

import operations.Operation;
import gui.Option;
import ij.io.OpenDialog;
import ij.io.Opener;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */


public class OpenImageOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = 5173632257684493168L;
	protected Option stringToBeReplaced;
	protected Option stringToReplaceWith;
	
	/** The folder in which the image file is. */
	protected String folder;
	/** The filename of the image file without path or folder. */
	protected String filename;
	protected String path;
	protected boolean resetPath = false;

	protected void initialize() throws ClassNotFoundException {	
		super.initialize();
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("java.lang.String");
		parameterNames = new String[1];
		parameterNames[0] = "Path";
		optionsNames = new String[2];
		optionsNames[0] = "replace string";
		optionsNames[1] = "replace with";
		resultTypes = new Class[2];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultTypes[1] = Class.forName("java.lang.String");
		resultNames = new String[2];
		resultNames[0] = "Result";
		resultNames[1] = "AbsoluteFilename";
	}
	
	/**
	 * Answer the folder in which the image file is.
	 * @return Returns the folder.
	 */
	public String getFolder() {
		return folder;
	}
	
	/**
	 * Set the folder in which the image file is.
	 * @param folder The folder to set.
	 */
	public void setFolder(String folder) {
		this.folder = folder;
	}
	
	/**
	 * 
	 */
	public void getFilenameFromUser() {
		OpenDialog openDialog = new OpenDialog("Open Image", "");
		filename = openDialog.getFileName();
		if (filename == null) {
			path = null;
			return;
		}
		folder = openDialog.getDirectory();
		OpenDialog.setDefaultDirectory(folder);
		path = folder + filename;
		resetPath = true;
	}

	/**
	 * 
	 */
	public void doIt() {
		String thePath = this.getPath();
		if (path==null) {
			this.stopApplication();
			return;
		}
		Opener opener = new Opener();
		int index = thePath.lastIndexOf(File.separator);
		String dir = thePath.substring(0, index+1);
		String filename = thePath.substring(index+1, thePath.length());
		result = opener.openImage(dir, filename);
	}

	public String getAbsoluteFilename() {
		return path;
	}
	
	public void setAbsoluteFilename(String path) {
		this.path = path;
	}
	/**
	 * @return Returns the filename.
	 */
	public String getFilename() {
		return filename;
	}
	/**
	 * @param filename The filename to set.
	 */
	public void setFilename(String filename) {
		this.filename = filename;
	}
	/**
	 * @return Returns the path.
	 */
	public String getPath() {
		if (path==null) {
			this.getFilenameFromUser();
		}
		if (!this.getStringToBeReplaced().equals("")) {
			System.out.println(this.substitutedPath());
			return this.substitutedPath();
		}
		return path;
	}
	/**
	 * @return
	 */
	private String substitutedPath() {
		return this.path.replaceAll(this.getStringToBeReplaced(), this.getStringToReplaceWith());
	}
	/**
	 * @param path The path to set.
	 */
	public void setPath(String path) {
		this.path = path;
	}
	
	// public String name() {
	//	return "open image";
	//}
	
	/**
	 * @return
	 */
	public Vector categories() {
		Vector categories = new Vector();
		categories.add("Input / Output");
		return categories;
	}
	
	/**
	 * 
	 */
	protected void cleanUpInput() {
		if (resetPath) this.path = null;
		resetPath = false;
	}
	
	public void resetPathOptions() {
		path = null;
	}
	
	public void setPathOptionsFromUser() {
		if (!this.isConnected()) {
			this.getFilenameFromUser();
			resetPath = false;
			if (path == null) {
				this.stopApplication();
				return;
			}
		}
	}
	/**
	 * @return Returns the stringToBeReplaced.
	 */
	public String getStringToBeReplaced() {
		return stringToBeReplaced.getValue();
	}
	/**
	 * @param stringToBeReplaced The stringToBeReplaced to set.
	 */
	public void setStringToBeReplaced(String stringToBeReplaced) {
		this.stringToBeReplaced.setValue(stringToBeReplaced);
	}
	/**
	 * @return Returns the stringToReplaceWith.
	 */
	public String getStringToReplaceWith() {
		return stringToReplaceWith.getValue();
	}
	/**
	 * @param stringToReplaceWith The stringToReplaceWith to set.
	 */
	public void setStringToReplaceWith(String stringToReplaceWith) {
		this.stringToReplaceWith.setValue(stringToReplaceWith);
	}
	
	protected void setupOptions() {
		super.setupOptions();
		this.setStringToBeReplaced("");
		this.stringToBeReplaced.setShortHelpText("enter the part of the filename to be replaced");
		this.stringToReplaceWith.setShortHelpText("enter the substitution for the part to be replaced");
	}
	
	public void connectOptions() {
		this.stringToBeReplaced = (Option) this.options.getOptions().elementAt(0);
		this.stringToReplaceWith = (Option) this.options.getOptions().elementAt(1);
	}
}
