/*
 * Created on 10.11.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gui;

import ij.ImagePlus;
import ij.ImageStack;
import ij.WindowManager;
import ij.gui.ImageCanvas;
import ij.gui.ImageWindow;
import ij.gui.NewImage;
import ij.gui.Roi;
import ij.plugin.RGBStackMerge;
import ij.plugin.filter.Duplicater;
import ij.plugin.filter.RGBStackSplitter;
import ij.process.ImageProcessor;
import ij.process.StackProcessor;
import java.awt.Point;
import java.awt.Rectangle;
import java.util.Observable;
import java.util.Observer;

import broadcaster.WindowManagerBroadcaster;




/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ChannelMixer extends Observable implements Observer {
	ImagePlus inputImageRGB;
	ImagePlus redOriginal;
	ImagePlus greenOriginal;
	ImagePlus blueOriginal;
	ImagePlus redTemp;
	ImagePlus greenTemp;
	ImagePlus blueTemp;
	protected double redMin;
	protected double redMax;
	protected double greenMin;
	protected double greenMax;
	protected double blueMin;
	protected double blueMax;
	protected boolean showRed;
	protected boolean showGreen;
	protected boolean showBlue;
	protected String modus;
	protected boolean keepAdjustment;
	RGBStackSplitter splitter = new RGBStackSplitter();
	Duplicater duplicater = new Duplicater();
	RGBStackMerge merger = new RGBStackMerge();
	protected ChannelMixerView view;
	
	public ChannelMixer(ImagePlus image) throws Exception {
		super();
		this.blockEvents();
		inputImageRGB = image;
		if (image == null || image.getType()!=ImagePlus.COLOR_RGB) {
			inputImageRGB = NewImage.createRGBImage("RGB", 80, 80, 1, NewImage.RGB);
			inputImageRGB.show();
		}
		this.setShowRed(true);
		this.setShowGreen(true);
		this.setShowBlue(true);
		this.setModus(this.modi()[1]);
		this.setKeepAdjustment(false);
		WindowManagerBroadcaster.getInstance().addObserver(this);
		this.initialize();
	}

	/**
	 * 
	 */
	private void initialize() {
		splitter.split(inputImageRGB.getStack(), true);
		redOriginal = new ImagePlus("red");
		redOriginal.setStack("red", splitter.red);
		greenOriginal = new ImagePlus("green");
		greenOriginal.setStack("green", splitter.green);
		blueOriginal = new ImagePlus("blue");
		blueOriginal.setStack("blue", splitter.blue);
		if (this.isKeepAdjustment()) {
			this.setRedMin(this.getRedMin());
			this.setRedMax(this.getRedMax());
			this.setGreenMin(this.getGreenMin());
			this.setGreenMax(this.getGreenMax());
			this.setBlueMin(this.getBlueMin());
			this.setBlueMax(this.getBlueMax());
		} else {
			this.setRedMin(redOriginal.getProcessor().getMin());
			this.setRedMax(redOriginal.getProcessor().getMax());
			this.setGreenMin(greenOriginal.getProcessor().getMin());
			this.setGreenMax(greenOriginal.getProcessor().getMax());
			this.setBlueMin(redOriginal.getProcessor().getMin());
			this.setBlueMax(redOriginal.getProcessor().getMax());
		}
		this.changed("minMax");
		this.changed("channelSelection");
		this.changed("modus");
	}
	
	/**
	 * @param string
	 */
	private void changed(String string) {
		this.setChanged();
		this.notifyObservers(string);
		this.clearChanged();
	}

	protected String[] modi() {
		String[] modi = {"min", "max"};
		return modi;
	}
	/**
	 * @return Returns the blueMax.
	 */
	public double getBlueMax() {
		return blueMax;
	}
	/**
	 * @param blueMax The blueMax to set.
	 */
	public void setBlueMax(double blueMax) {
		this.blueMax = blueMax;
		this.updateImages();
	}
	/**
	 * @return Returns the blueMin.
	 */
	public double getBlueMin() {
		return blueMin;
	}
	/**
	 * @param blueMin The blueMin to set.
	 */
	public void setBlueMin(double blueMin) {
		this.blueMin = blueMin;
		this.updateImages();
	}
	/**
	 * @return Returns the greenMax.
	 */
	public double getGreenMax() {
		return greenMax;
	}
	/**
	 * @param greenMax The greenMax to set.
	 */
	public void setGreenMax(double greenMax) {
		this.greenMax = greenMax;
		this.updateImages();
	}
	/**
	 * @return Returns the greenMin.
	 */
	public double getGreenMin() {
		return greenMin;
	}
	/**
	 * @param greenMin The greenMin to set.
	 */
	public void setGreenMin(double greenMin) {
		this.greenMin = greenMin;
		this.updateImages();
	}
	/**
	 * 
	 */
	public void updateImages() {
		redTemp = duplicater.duplicateStack(redOriginal, inputImageRGB.getTitle());
		greenTemp = duplicater.duplicateStack(greenOriginal, inputImageRGB.getTitle());
		blueTemp = duplicater.duplicateStack(blueOriginal, inputImageRGB.getTitle());
		redTemp.getProcessor().setMinAndMax(this.getRedMin(), this.getRedMax());
		this.apply(redTemp, redTemp.getProcessor());
		ImageStack red = null;
		if (isShowRed()) {
			red = redTemp.getStack();
		}
		greenTemp.getProcessor().setMinAndMax(this.getGreenMin(), this.getGreenMax());
		this.apply(greenTemp, greenTemp.getProcessor());
		ImageStack green = null;
		if (isShowGreen()) {
			green = greenTemp.getStack();
		}
		blueTemp.getProcessor().setMinAndMax(this.getBlueMin(), this.getBlueMax());
		this.apply(blueTemp, blueTemp.getProcessor());
		ImageStack blue = null;
		if (isShowBlue()) {
			blue = blueTemp.getStack();
		}
		ImageStack merged = merger.mergeStacks(inputImageRGB.getWidth(), inputImageRGB.getHeight(), inputImageRGB.getStackSize(),
							red, green, blue, true);
		Rectangle oldBounds = inputImageRGB.getWindow().getBounds();
		Roi oldRoi = inputImageRGB.getRoi();
		Rectangle position = inputImageRGB.getWindow().getCanvas().getSrcRect();
		double lastZoom = inputImageRGB.getWindow().getCanvas().getMagnification();
		inputImageRGB.setStack(inputImageRGB.getTitle(), merged);
		inputImageRGB.getWindow().setVisible(false);
		inputImageRGB.getWindow().setBounds(oldBounds);
		if (inputImageRGB.getWindow().getCanvas().getMagnification()<lastZoom) this.zoomIn(inputImageRGB.getWindow(), lastZoom);
		if (inputImageRGB.getWindow().getCanvas().getMagnification()>lastZoom) this.zoomOut(inputImageRGB.getWindow(), lastZoom);
		//inputImageRGB.getWindow().getCanvas().setSrcRect(position);
		inputImageRGB.getWindow().getCanvas().getSrcRect().setBounds(position);
		if (oldRoi!=null) inputImageRGB.setRoi(oldRoi);
		inputImageRGB.getWindow().setVisible(true);
	}

	/**
	 * @return Returns the redMax.
	 */
	public double getRedMax() {
		return redMax;
	}
	/**
	 * @param redMax The redMax to set.
	 */
	public void setRedMax(double redMax) {
		this.redMax = redMax;
		this.updateImages();
	}
	/**
	 * @return Returns the redMin.
	 */
	public double getRedMin() {
		return redMin;
	}
	/**
	 * @param redMin The redMin to set.
	 */
	public void setRedMin(double redMin) {
		this.redMin = redMin;
		this.updateImages();
	}
	/**
	 * @return Returns the showBlue.
	 */
	public boolean isShowBlue() {
		return showBlue;
	}
	/**
	 * @param showBlue The showBlue to set.
	 */
	public void setShowBlue(boolean showBlue) {
		this.showBlue = showBlue;
	}
	/**
	 * @return Returns the showGreen.
	 */
	public boolean isShowGreen() {
		return showGreen;
	}
	/**
	 * @param showGreen The showGreen to set.
	 */
	public void setShowGreen(boolean showGreen) {
		this.showGreen = showGreen;
	}
	/**
	 * @return Returns the showRed.
	 */
	public boolean isShowRed() {
		return showRed;
	}
	/**
	 * @param showRed The showRed to set.
	 */
	public void setShowRed(boolean showRed) {
		this.showRed = showRed;
	}
	/**
	 * @return Returns the modus.
	 */
	public String getModus() {
		return modus;
	}
	/**
	 * @param modus The modus to set.
	 */
	public void setModus(String modus) {
		this.modus = modus;
		this.changed("minMax");
	}
	
	public void show() {
		this.getView().setVisible(true);
		this.changed("minMax");
		this.changed("channelSelection");
		this.changed("modus");
		this.unblockEvents();
	}

	/**
	 * @return
	 */
	private ChannelMixerView getView() {
		if (view==null) {
			view = new ChannelMixerView(this);
		}
		return view;
	}

	/* (non-Javadoc)
	 * @see java.util.Observer#update(java.util.Observable, java.lang.Object)
	 */
	public void update(Observable arg0, Object anAspect) {
		ImagePlus newInputImage = WindowManager.getCurrentImage();
		if (newInputImage.getTitle().contains("Pixel Spy")) return;
		if (newInputImage==null || newInputImage.getWindow()==null ) return;
		if (newInputImage==inputImageRGB) return;
		if (anAspect.equals("currentImage")) {
			inputImageRGB.getWindow().close();
			inputImageRGB = newInputImage;
			inputImageRGB.show();
			this.initialize();
			this.unblockEvents();
		}
	}

	/**
	 * 
	 */
	public void close() {
		WindowManagerBroadcaster.getInstance().deleteObserver(this);
	}
	
	public void apply(ImagePlus imp, ImageProcessor ip) {
		int[] table = new int[256];
		int min = (int)ip.getMin();
		int max = (int)ip.getMax();
		for (int i=0; i<256; i++) {
			if (i<=min)
				table[i] = 0;
			else if (i>=max)
				table[i] = 255;
			else
				table[i] = (int)(((double)(i-min)/(max-min))*255);
		}
		ip.setRoi(imp.getRoi());
		if (imp.getStackSize()>1) {
			ImageStack stack = imp.getStack();
				new StackProcessor(stack, ip).applyTable(table);
		} else {
			if (ip.getMask()!=null)	 ip.snapshot();
			ip.applyTable(table);
			ip.reset(ip.getMask());
		}
		//reset(imp, ip);
		imp.changes = true;
		imp.unlock();
	}

	/**
	 * 
	 */
	public void blockEvents() {
		if (PixelSpy.isActive()) {
			WindowManagerBroadcaster.getInstance().deleteObserver(PixelSpy.current);
		}
	}

	/**
	 * 
	 */
	public void unblockEvents() {
		if (PixelSpy.isActive()) {
			//PixelSpy.getCurrent(inputImageRGB);
			WindowManagerBroadcaster.getInstance().addObserver(PixelSpy.current);
			PixelSpy.current.updateAnywaw();
		}
	}
	
	/**
	 * 
	 */
	private void zoomOut(ImageWindow win, double lastZoom) {
		while(win.getCanvas().getMagnification()>lastZoom) {
			if (win==null) return;
			ImageCanvas ic = win.getCanvas();
			Point loc = ic.getCursorLoc();
			int x = ic.screenX(loc.x);
			int y = ic.screenY(loc.y);
			ic.zoomOut(x, y);
			}
		}
		
	/**
	 * 
	 */
	private void zoomIn(ImageWindow win, double lastZoom) {
		while(win.getCanvas().getMagnification()<lastZoom) {
			if (win==null) return;
			ImageCanvas ic = win.getCanvas();
			Point loc = ic.getCursorLoc();
			int x = ic.screenX(loc.x);
			int y = ic.screenY(loc.y);
			ic.zoomIn(x, y);			
			}
	}

	/**
	 * 
	 */
	public void toggleKeepAdjustment() {
		this.setKeepAdjustment(!this.isKeepAdjustment());
		
	}
	/**
	 * @return Returns the keepAdjustment.
	 */
	public boolean isKeepAdjustment() {
		return keepAdjustment;
	}
	/**
	 * @param keepAdjustment The keepAdjustment to set.
	 */
	public void setKeepAdjustment(boolean keepAdjustment) {
		this.keepAdjustment = keepAdjustment;
		this.changed("keepAdjustment");
	}
}
