/*
 * Created on 26.08.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gui;

import java.io.File;
import javax.swing.filechooser.FileFilter;

import neuronJNewGUI.ConfigurableFileFilter;

import java.util.Arrays;
import java.util.Iterator;
import java.util.Observable;
import java.util.Vector;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ListEditor extends Observable {
	protected ListEditorView view;
	protected Vector list;
	protected boolean showPath = true;
	protected boolean useSequenceOpener = false;
	
	public void show() {
		this.view().setVisible(true);
		this.changed("list");
	}

	
	/**
	 * @return Returns the view.	
	 */
	public ListEditorView view() {
		if (this.view == null) {
			this.view = new ListEditorView(this);
		}
		return this.view;
	}


	/**
	 * 
	 */
	public static ConfigurableFileFilter getTiffFileFilter() {
		String[] extensions = {"tif", "tiff", "TIF", "TIFF"};
		ConfigurableFileFilter filter = new ConfigurableFileFilter(extensions, "tif images");
		return filter;
	}
	
	public static ConfigurableFileFilter getImageFileFilter() {
		String[] extensions = {"tiff", "tif", "TIF", "TIFF", "gif", "GIF", "jpg", "JPG", "bmp", "BMP", "pgm", "PGM", "stk", "STK"};
		ConfigurableFileFilter filter = new ConfigurableFileFilter(extensions, "all images");
		return filter;
	}


	/**
	 * @param selectedFiles
	 */
	public void addToList(File[] selectedFiles, FileFilter filter) {
		for(int i=0; i<selectedFiles.length;i++) {
			File aFile = selectedFiles[i];
			if (!filter.accept(aFile)) {
				selectedFiles[i] = null;
				continue;
			}
			if (aFile.isDirectory()) {
				this.addToList(aFile.listFiles(), (FileFilter)filter);
				selectedFiles[i] = null;
			}
		}
		Vector fileList = new Vector();
		fileList.addAll(Arrays.asList(selectedFiles));
		while (fileList.remove(null));
		this.getList().addAll(fileList);
		this.changed("list");
	}

	/**
	 * @param selectedFiles
	 */
	public void addToList(File[] selectedFiles) {
		Vector fileList = new Vector();
		fileList.addAll(Arrays.asList(selectedFiles));
		while (fileList.remove(null));
		this.getList().addAll(fileList);
		this.changed("list");
	}

	/**
	 * @param string
	 */
	private void changed(String anAspect) {
		this.setChanged();
		this.notifyObservers(anAspect);
	}


	/**
	 * answer the list of files.
	 * @return Vector of File
	 */
	public Vector getList() {
		if (list==null) {
			list = new Vector();
		}
		return list;
	}


	/**
	 * @param toBeRemoved
	 */
	public void removeElementsFromList(Object[] toBeRemoved) {
		for(int i=0; i<toBeRemoved.length; i++) {
			this.getList().remove(toBeRemoved[i]);
		}
		this.changed("list");
	}
	/**
	 * @param list The list to set.
	 */
	public void setList(Vector list) {
		this.list = list;
	}


	/**
	 * @return
	 */
	
	public static ConfigurableFileFilter getExcelFileFilter() {
		String[] extensions = {"xls"};
		ConfigurableFileFilter filter = new ConfigurableFileFilter(extensions, "excel");
		return filter;
	}


	/**
	 * @param b
	 */
	public void setUseSequenceOpener(boolean value) {
		this.useSequenceOpener = value;
	}


	public int[] getItemsMatching(String text) {
		Vector indices = new Vector();
		Iterator it = list.iterator();
		while (it.hasNext()) {
			File current = (File)it.next();
			if (current.getPath().contains(text)) indices.add(new Integer(list.indexOf(current)));
		}
		int[] result = new int[indices.size()];
		int index = 0;
		it = indices.iterator();
		while (it.hasNext()) {
			Integer current = (Integer) it.next();
			result[index] = current.intValue();
			index++;
		}
		return result;
	}
}
