package gui;

import java.util.Observable;
import java.util.Vector;

public class MultiChannelListEditor extends Observable {
	private MultiChannelListEditorView view;
	protected int numberOfChannels = 2;
	protected Vector channels;

	public MultiChannelListEditor() {
		super();
		this.view = new MultiChannelListEditorView(this);
		for (int i=0; i<this.getNumberOfChannels(); i++) {
			this.addChannel();
		}
	}
	
	public void show() {
		this.getView().setVisible(true);
	}

	public MultiChannelListEditorView getView() {
		if (this.view==null) {
			this.view = new MultiChannelListEditorView(this);
		}
		return view;
	}

	public int getNumberOfChannels() {
		return numberOfChannels;
	}

	public void setNumberOfChannels(int numberOfChannels) {
		this.numberOfChannels = numberOfChannels;
	}

	public Vector getChannels() {
		if (channels==null) {
			channels = new Vector();
		}
		return channels;
	}

	public void addChannel() {
		ListEditor list = new ListEditor();
		this.getChannels().add(list);
		ListEditorView view = list.view();
		view.getJPanel3().removeAll();
		this.view.getEditorPanel().add(view.getJFrameContentPane());
	}

	public void changed(String string) {
			this.setChanged();
			this.notifyObservers(string);
	}
}
