/*
 * Created on 07.07.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gui;

import help.HelpSystem;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.Serializable;
import java.util.Observable;
import java.util.Vector;
import operations.Operation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Option extends Observable implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -3283260319080715983L;
	protected OptionView view;
	protected String name;
	protected Double min;
	protected Double max;
	protected String value;
	protected String shortHelpText;
	private boolean isForFilename = false;
	
	/**
	 * Default Constructor. Initializes the application.
	 *
	 */
	public Option() {
		this.initialize();
	}
	
	/**
	 * Initialize the application. Create the view and register myself as model. 
	 */
	protected void initialize() {
		name = "unnamed option";
	}
	
	/**
	 * @return Returns the value.
	 */
	public String getValue() {
		return value;
	}
	/**
	 * @param value The value to set.
	 */
	public void setValue(String value) {
		this.value = value;
		this.changed("value");
	}
	
	public OptionView newView() {
		OptionView newView = new OptionView(this);
		this.addObserver(newView);
		return newView;
	}
	
	public double getDoubleValue() {
		double doubleValue = (Double.parseDouble(this.getValue()));
		return doubleValue;
	}
	
	public float getFloatValue() {
		float floatValue = (Float.parseFloat(this.getValue()));
		return floatValue;
	}
	
	public boolean getBooleanValue() {
		return false;
	}
	
	public float[] getMatrixValue() {
		float[] result = {};
		return result;
	}
	
	public Vector getListValue() {
		Vector result = new Vector();
		return result;
	}
	
	public int getIntegerValue() {
		int integerValue = (Integer.parseInt(this.getValue()));
		return integerValue;
	}
	/**
	 * @return Returns the max.
	 */
	public Double getMax() {
		return max;
	}
	/**
	 * @param max The max to set.
	 */
	public void setMax(double max) {
		this.max = new Double(max);
	}
	/**
	 * @return Returns the min.
	 */
	public Double getMin() {
		return min;
	}
	/**
	 * @param min The min to set.
	 */
	public void setMin(double min) {
		this.min = new Double(min);
	}
	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}
	/**
	 * @param name The name to set.
	 */
	public void setName(String name) {
		this.name = name;
		this.changed("name");
	}
	/**
	 * @param string
	 */
	private void changed(String string) {
		this.setChanged();
		this.notifyObservers(string);
		this.clearChanged();
	}

	/**
	 * @return Returns the view.
	 */
	public OptionView getView() {
		if (view==null) {
			view = new OptionView(this);
			this.addObserver(view);
		}
		return view;
	}
	/**
	 * @param view The view to set.
	 */
	public void setView(OptionView view) {
		this.view = view;
	}

	/**
	 * @return
	 */
	public String getRangeString() {
		if (this.getMin()==null && this.getMax()==null) return "";
		String min = this.getMin() + "";
		if (this.getMin()==null) {
			min = "-";
		}
		String max = this.getMax() + "";
		if (this.getMax()==null) {
			max = "-";
		}
		String result = "[" + min + ", " + max + "]";
		return result;
	}

	/**
	 * @return
	 */
	public String getShortHelpText() {
		if (this.shortHelpText==null) {
			this.shortHelpText = "";
		}
		return shortHelpText;
	}
	/**
	 * @param shortHelpText The shortHelpText to set.
	 */
	public void setShortHelpText(String shortHelpText) {
		this.shortHelpText = shortHelpText;
	}

	/**
	 * @return
	 */
	public boolean isBoolean() {
		// TODO Auto-generated method stub
		return false;
	}
	
	/**
	 * @return
	 */
	public boolean isChoice() {
		// TODO Auto-generated method stub
		return false;
	}
	
	public String[] getChoices() {
		return null;
	}

	public boolean isMatrix() {
		return false;
	}
	
	public boolean isList() {
		return false;
	}
	
	/**
	 * @param out
	 * @throws IOException
	 */
	public void printOn(BufferedWriter out) throws IOException {
			out.write(this.getClass().getName() + "\n");
			out.write(this.getName() + "\n" );
			out.write(this.getValue()+"\n");
			out.write(this.getMin() + "\n");
			out.write(this.getMax() + "\n");
			out.write(this.getShortHelpText() + "\n");
	}
	
	public static Option readFrom(BufferedReader in) throws IOException {
		IOException error = new IOException();
		String className = in.readLine();
		Option option = null;
		try {
			option = (Option)Class.forName(className).newInstance();
			option.setupFrom(in);
		} catch (InstantiationException e) {
			error.setStackTrace(e.getStackTrace());
			throw error;
		} catch (IllegalAccessException e) {
			error.setStackTrace(e.getStackTrace());
			throw error;
		} catch (ClassNotFoundException e) {
			error.setStackTrace(e.getStackTrace());
			throw error;
		}
		return option;
	}
	
	public void setupFrom(BufferedReader in) throws IOException {
		String optionName = in.readLine();
		String value = in.readLine();
		String input = in.readLine();
		Double min; 
		if (input.equals("null")) {
			min = null;
		} else {
			min = Double.valueOf(input);
		}
		input = in.readLine();
		Double max; 
		if (input.equals("null")) {
			max = null;
		} else {
			max = Double.valueOf(input);
		}
		String shortHelpText = in.readLine();
		this.setName(optionName);
		this.setValue(value);
		if (min!=null) {
			this.setMin(min.doubleValue());
		}
		if (max!=null) {
			this.setMax(max.doubleValue());
		}
		this.setShortHelpText(shortHelpText);
	}

	/**
	 * @param operationName
	 */
	public void openHelpFor(String operationName) {
		HelpSystem help = HelpSystem.getCurrent();
		help.openHelpFor(operationName, this.getName());
		
	}

	/**
	 * 
	 */
	public ListEditor openEditor() {
		return null;		
	}

	/**
	 * @param operation
	 * 
	 */
	public void browse(Operation operation) {
		operation.browseFileForOption(this);
	}

	/**
	 * @return
	 */
	public boolean isForFilename() {
		return isForFilename;
	}
	
	public void beForFilename() {
		isForFilename = true;
	}
}
