package gui;

import java.util.Observable;

public class ProgressBar extends Observable {
	protected int min;
	protected int max;
	protected int progress;
	protected String text;
	protected boolean closeWhenFinished;
	protected ProgressBarView view;
	
	public ProgressBar(int min, int max, String text) {
		this.setMin(min);
		this.setMax(max);
		this.setProgress(min);
		this.setText(text);
	}

	public int getProgress() {
		return progress;
	}

	public void setProgress(int current) {
		this.progress = current;
		this.changed("progress");
	}

	public int getMax() {
		return max;
	}

	public void setMax(int max) {
		this.max = max;
		this.changed("max");
	}

	public int getMin() {
		return min;
	}

	public void setMin(int min) {
		this.min = min;
		this.changed("min");
	}
	
	public void changed(String string) {
		this.setChanged();
		this.notifyObservers(string);
		this.clearChanged();
	}

	public String getText() {
		return text;
	}
	
	public void setText(String aText) {
		this.text = aText;
		this.changed("text");
	}

	public boolean isCloseWhenFinished() {
		return closeWhenFinished;
	}

	public void setCloseWhenFinished(boolean closeWhenFinished) {
		this.closeWhenFinished = closeWhenFinished;
	}

	public ProgressBarView getView() {
		if (this.view==null) this.view  = new ProgressBarView(this);
		return view;
	}
}
