/*
 * Created on 20.01.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package imageOperations;

import ij.ImagePlus;
import imagejProxies.ExtendedLutLoader;
import java.util.Vector;
import neuronJNewGUI.LookupTableSelector;
import gui.ChoiceOption;
import gui.Options;
import operations.Operation;

/**
 * @author Volker
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class ApplyLutOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = -1293315312188604087L;

	ChoiceOption lookupTable;

	private LookupTableSelector lutSelector;

	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		optionsNames = new String[1];
		optionsNames[0] = "lookup tables";
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultNames = new String[1];
		resultNames[0] = "Result";
		lutSelector = new LookupTableSelector();
	}

	public void doIt() {
		ImagePlus inputImage = this.getInputImage();
		result = this.getCopyOfOrReferenceTo(inputImage, inputImage.getTitle());
		boolean noWin = result.getWindow()==null;
		if (noWin)result.show();
		ExtendedLutLoader loader = new ExtendedLutLoader();
		String lutName = lutSelector.getFullLutNameFor(this.getLookupTable());
		loader.applyLut(lutName);
		if (noWin) result.hide();
	}

	public void connectOptions() {
		this.lookupTable = (ChoiceOption) this.options.getOptions()
				.elementAt(0);
	}

	protected void setupOptions() {
		options = new Options();
		options.setName(this.name() + " options");
		String[] optionsNames = this.getOptionsNames();
		Vector choices = lutSelector.getAllLutNames();
		this.lookupTable = new ChoiceOption(choices);
		lookupTable.setName(optionsNames[0]);
		lookupTable.setShortHelpText("select the lookup table");
		lookupTable.setValue((String) choices.elementAt(0));
		options.add(this.lookupTable);
	}

	/**
	 * @return Returns the lookupTable.
	 */
	public String getLookupTable() {
		return lookupTable.getValue();
	}

	/**
	 * @param lookupTable
	 *            The lookupTable to set.
	 */
	public void setLookupTable(String lookupTable) {
		this.lookupTable.setValue(lookupTable);
	}
}