/*
 * Created on 20.07.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package imageOperations;

import ij.ImagePlus;
import imagejProxies.MRIConverter;
import gui.ChoiceOption;
import gui.Options;
import operations.Operation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ConvertImageTypeOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = -1884637314382451366L;
	protected ChoiceOption outputType;

	public void doIt() {
		ImagePlus inputImage = this.getInputImage();
		result = this.getCopyOfOrReferenceTo(inputImage, inputImage.getTitle());
		MRIConverter converter = new MRIConverter(result);
		converter.run(this.getOutputType());
	}
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		optionsNames = new String[1];
		optionsNames[0] = "output type";
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultNames = new String[1];
		resultNames[0] = "Result";
	}
	
	/**
	 * @return Returns the outputType.
	 */
	public String getOutputType() {
		return outputType.getValue();
	}
	/**
	 * @param outputType The outputType to set.
	 */
	public void setOutputType(String outputType) {
		this.outputType.setValue(outputType);
	}
	
	public void convertTo8Bit() {
		this.setOutputType("8-bit");
	}
	
	public void convertTo16Bit() {
		this.setOutputType("16-bit");
	}
	
	public void convertTo32Bit() {
		this.setOutputType("32-bit");
	}
	public void convertTo8BitColor() {
		this.setOutputType("8-bit Color");
	}
	
	public void convertToRGBColor() {
		this.setOutputType("RGB Color");
	}
	
	public void convertToRGBStack() {
		this.setOutputType("RGB Stack");
	}
	
	public void convertToHSBStack() {
		this.setOutputType("HSB Stack");
	}
	
	public String[] outputTypes() {
		String[] types = {"8-bit", "16-bit", "32-bit", "8-bit Color", "RGB Color", "RGB Stack", "HSB Stack"};
		return types;
	}
	protected void setupOptions() {
		options = new Options(); 
		options.setName(this.name() + " options");
		String[] optionsNames = this.getOptionsNames();
		this.outputType = new ChoiceOption(this.outputTypes());
		this.outputType.setValue(this.outputTypes()[0]);
		this.outputType.setName(optionsNames[0]);
		this.outputType.setShortHelpText("choose the type of the result image");
		options.add(this.outputType);
	}
	
	public void connectOptions() {
		outputType = (ChoiceOption) options.getOptions().elementAt(0);
	}
}
