/*
 * Created on 13.10.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package imageOperations;

import java.util.Arrays;

import ij.ImagePlus;
import ij.WindowManager;
import imagejProxies.SilentImageCalculator;
import operations.Operation;
import gui.BooleanOption;
import gui.ChoiceOption;
import gui.Options;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ImageCalculationOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = -8122064832127165532L;
	protected ChoiceOption operator;
	protected BooleanOption floatResult;
	
	protected ImagePlus secondInputImage;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		optionsNames = new String[2];
		optionsNames[0] = "operator";
		optionsNames[1] = "float result";
		parameterTypes = new Class[2];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterTypes[1] = Class.forName("ij.ImagePlus");
		parameterNames = new String[2];
		parameterNames[0] = "InputImage";
		parameterNames[1] = "SecondInputImage";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultNames = new String[1];
		resultNames[0] = "Result";
	}

	protected void setupOptions() {
		options = new Options(); 
		options.setName(this.name() + " options");
		String[] optionsNames = this.getOptionsNames();
		this.operator = new ChoiceOption(this.operators());
		this.operator.setValue(this.operators()[0]);
		this.operator.setName(optionsNames[0]);
		this.operator.setShortHelpText("select an operation");
		options.add(this.operator);
		this.floatResult = new BooleanOption();
		this.setFloatResult(false);
		floatResult.setName(optionsNames[1]);
		floatResult.setShortHelpText("create a float image as result");
		options.add(this.floatResult);
	}

	/**
	 * @return
	 */
	private String[] operators() {
		String[] operators = {"Add","Subtract","Multiply","Divide", "AND", "OR", "XOR", "Min", "Max", "Average", "Difference", "Copy"};
		return operators;
	}

	public void doIt() {
		ImagePlus inputImage = this.getInputImage();
		result = this.getCopyOfOrReferenceTo(inputImage, inputImage.getTitle());
		SilentImageCalculator calculator = new SilentImageCalculator();
		calculator.setFloatResult(this.getFloatResult());
		calculator.setOperator(Arrays.asList(this.operators()).indexOf(this.getOperator()));
		calculator.setCreateWindow(false);
		calculator.run(result, this.getSecondInputImage());
	}
	
	public void connectOptions() {
		this.operator = (ChoiceOption) this.options.getOptions().elementAt(0);
		this.floatResult = (BooleanOption) this.options.getOptions().elementAt(1);
	}
	
	/**
	 * @return Returns the floatResult.
	 */
	public boolean getFloatResult() {
		return floatResult.getBooleanValue();
	}
	/**
	 * @param floatResult The floatResult to set.
	 */
	public void setFloatResult(boolean floatResult) {
		this.floatResult.setValue(Boolean.toString(floatResult));
	}
	/**
	 * @return Returns the operator.
	 */
	public String getOperator() {
		return operator.getValue();
	}
	/**
	 * @param operator The operator to set.
	 */
	public void setOperator(String operator) {
		this.operator.setValue(operator);
	}
	/**
	 * @return Returns the secondInputImage.
	 */
	public ImagePlus getSecondInputImage() {
		if (secondInputImage==null) {
			secondInputImage = WindowManager.getCurrentImage();
		}
		return secondInputImage;
	}
	/**
	 * @param secondInputImage The secondInputImage to set.
	 */
	public void setSecondInputImage(ImagePlus secondInputImage) {
		this.secondInputImage = secondInputImage;
	}
	
	protected void cleanUpInput() {
		super.cleanUpInput();
		this.setSecondInputImage(null);	
	}
}
