/*
 * Created on 31.08.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package neuronJNewGUI;


import ij.IJ;
import ij.ImageJ;
import ij.ImagePlus;
import ij.WindowManager;
import ij.gui.ImageWindow;
import ij.io.OpenDialog;
import ij.io.Opener;
import imagejProxies.ExtendedLutLoader;

import java.awt.Rectangle;
import java.io.File;
import java.util.Arrays;
import java.util.Observable;
import java.util.Vector;

import javax.swing.JFileChooser;

import utils.Zoom;

import broadcaster.ObservableContrastAdjuster;

import neuronJgui.ImageFilter;
import neuronJgui.NJ;
import neuronJgui.TracingToolbar;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SlideShowControl extends Observable {
	protected SlideShowControlView view;
	protected SlideShowControlOptionsView optionsView;
	protected String message;
	protected File currentFolder;
	protected File currentFile;
	protected Vector fileList;
	protected boolean loadUsingNeuronJ;
	protected boolean adjustBrightness;
	protected boolean auto;
	protected int min;
	protected int max;
	protected boolean applyLookupTable;
	protected String lookupTable;
	protected Vector lookupTables;
	private LookupTableSelector lookupTableSelector;
	private boolean closeAllImages;
	private boolean closeLastImage;
	public ImageWindow lastOpened;
	protected boolean keepPosition;
	private Rectangle lastBounds;
	private double lastZoom;
	
	/**
	 * @return Returns the loadUsingNeuronJ.
	 */
	public boolean isLoadUsingNeuronJ() {
		return loadUsingNeuronJ;
	}
	/**
	 * @param loadUsingNeuronJ The loadUsingNeuronJ to set.
	 */
	public void setLoadUsingNeuronJ(boolean loadUsingNeuronJ) {
		this.loadUsingNeuronJ = loadUsingNeuronJ;
	}
	
	public SlideShowControl() {
		super();
		this.initialize();
	}
	/**
	 * 
	 */
	private void initialize() {
		if (IJ.getInstance() == null) {
			new ImageJ();
			IJ.getInstance().setVisible(false);
		}
		this.getView();
		String folderName = OpenDialog.getDefaultDirectory();
		if (folderName=="") {
			folderName = System.getProperty("user.home");
		}
		this.setCurrentFolder(new File(folderName));
		this.setupLookupTables();
		this.setCloseLastImage(true);
		this.setKeepPosition(true);
	}
	
	/**
	 * 
	 */
	private void setupLookupTables() {
		lookupTableSelector = new LookupTableSelector();
		lookupTables = lookupTableSelector.getAllLutNames();
	}
	
	/**
	 * @return Returns the view.
	 */
	public SlideShowControlView getView() {
		if (view==null) {
			view = new SlideShowControlView(this);
		}
		this.changed("lookupTables");
		return view;
	}
	
	public void show() {
		this.getView().setVisible(true);
	}
	
	protected void changed(String anAspect) {
		this.setChanged();
		this.notifyObservers(anAspect);
		this.clearChanged();
	}
	
	/**
	 * @return Returns the currentFile.
	 */
	public File getCurrentFile() {
		return currentFile;
	}
	/**
	 * @param currentFile The currentFile to set.
	 */
	public void setCurrentFile(File currentFile) {
		this.currentFile = currentFile;
		this.setMessage(this.createMessage());
	}
	/**
	 * @return Returns the currentFolder.
	 */
	public File getCurrentFolder() {
		return currentFolder;
	}
	/**
	 * @param currentFolder The currentFolder to set.
	 */
	public void setCurrentFolder(File currentFolder) {
		this.currentFolder = currentFolder;
		this.setFileList(this.createFileList());
		this.setMessage(this.createMessage());
		OpenDialog.setDefaultDirectory(currentFolder.getAbsolutePath());
	}
	/**
	 * @return
	 */
	private Vector createFileList() {
		if (this.getCurrentFolder()==null) return new Vector();
		File[] list = this.getCurrentFolder().listFiles(new ImageFilter());
		Vector result = new Vector();
		if (!(list==null)) {
			result.addAll(Arrays.asList(list));
		}
		return result;
	}
	/**
	 * @return
	 */
	private String createMessage() {
		String result = "";
		if (this.getCurrentFolder()==null) {
			result = "no folder selected";
			return result;
		}
		if (this.getCurrentFile()==null) {
			result = "-" + "/" + this.getFileList().size() + " " + this.getCurrentFolder().getName();
			return result;
		}
		int index = this.getFileList().indexOf(this.getCurrentFile()) + 1;
		result = result = index + "/" + this.getFileList().size() + " " + this.getCurrentFolder().getName();;
		return result;
	}
	/**
	 * @return Returns the fileList.
	 */
	public Vector getFileList() {
		return fileList;
	}
	/**
	 * @param fileList The fileList to set.
	 */
	public void setFileList(Vector fileList) {
		this.fileList = fileList;
	}
	/**
	 * @return Returns the message.
	 */
	public String getMessage() {
		return message;
	}
	/**
	 * @param message The message to set.
	 */
	public void setMessage(String message) {
		this.message = message;
		this.changed("message");
	}
	/**
	 * 
	 */
	public void showNextImage() {
		if (fileList.size()==0) return;
		if (this.currentFile==null) {
			this.currentFile = (File)fileList.elementAt(0);
		} else {
			int index = fileList.indexOf(currentFile);
			if (index>=fileList.size()-1) return;
			index++;
			this.currentFile = (File)fileList.elementAt(index);
		}
		this.loadAndShowCurrentFile();
		this.setMessage(this.createMessage());
	}
	
	/**
	 * 
	 */
	public void showPreviousImage() {
		if (fileList.size()==0) return;
		if (this.currentFile==null) {
			this.currentFile = (File)fileList.elementAt(0);
		} else {
			int index = this.getFileList().indexOf(this.getCurrentFile());
			if (index<=0) return;
			index--;
			this.currentFile = (File)fileList.elementAt(index);
		}
		this.loadAndShowCurrentFile();
		this.setMessage(this.createMessage());
	}
	
	/**
	 * 
	 */
	public void showFirstImage() {
		if (fileList.size()==0) return;
		if (this.getCurrentFile()!=null) {
			int index = this.getFileList().indexOf(this.getCurrentFile());
			if (index==0) return;
		}
		this.currentFile = (File) fileList.elementAt(0);
		this.loadAndShowCurrentFile();
		this.setMessage(this.createMessage());
	}
	
	/**
	 * 
	 */
	public void showLastImage() {
		if (fileList.size()==0) return;
		if (this.getCurrentFile()!=null) {
			int index = this.getFileList().indexOf(this.getCurrentFile());
			if (index==fileList.size()-1) return;
		}
		this.currentFile = (File) fileList.elementAt(fileList.size()-1);
		this.loadAndShowCurrentFile();
		this.setMessage(this.createMessage());
	}
	
	/**
	 * 
	 */
	public void loadAndShowCurrentFile() {
		if (this.currentFile==null) return;
		this.handleOpenWindows();
		if (this.isLoadUsingNeuronJ()) {
			this.neuronJLoadFile();
		} else {
			this.standardLoadCurrentFile();
		}
		lastOpened = WindowManager.getCurrentWindow();
		if (this.isKeepPosition() && lastBounds != null) {
			lastOpened.setVisible(false);
			lastOpened.setBounds(lastBounds);
			Zoom.zoomTo(lastOpened, lastZoom);
			lastOpened.setVisible(true);
		}
		this.adjustImageDisplay();
	}
	
	/**
	 * 
	 */
	private void handleOpenWindows() {
		if (this.closeLastImage) {
			if (lastOpened!=null) {
				lastBounds = lastOpened.getBounds();
				lastZoom = lastOpened.getCanvas().getMagnification();
				if (this.isLoadUsingNeuronJ()) {lastOpened.getImagePlus().changes=false;}
				lastOpened.close();
			}
		}
		if (this.closeAllImages) {
			WindowManager.closeAllWindows();
		}
	}
	/**
	 * 
	 */
	private void adjustImageDisplay() {
		if (this.isApplyLookupTable()) {
			String lut = lookupTableSelector.getFullLutNameFor(getLookupTable());
			ExtendedLutLoader loader = new ExtendedLutLoader();
			loader.run(lut);
		}
		if (this.isAdjustBrightness()) {
			this.adjustBrightness();
		}
	}
	/**
	 * 
	 */
	private void adjustBrightness() {
		ImagePlus image = WindowManager.getCurrentImage();
		if (this.isAuto()) {
			ObservableContrastAdjuster adjuster = new ObservableContrastAdjuster();
			adjuster.autoAdjust(image, image.getProcessor());
			image.updateAndDraw();
			return;
		} else {
			ObservableContrastAdjuster adjuster = new ObservableContrastAdjuster();
			System.out.println(this.getMin());
			System.out.println(this.getMax());
			adjuster.setMinAndMax(image.getProcessor(), this.getMin(), this.getMax());
			image.updateAndDraw();
		}
		
	}
	/**
	 * 
	 */
	private void neuronJLoadFile() {
		if (NJ.ntb==null) {
			standardLoadCurrentFile();
			return;
		}
		NJ.ntb.loadImage(currentFile.getParentFile().getAbsolutePath(), currentFile.getName());
		NJ.ntb.setTool(TracingToolbar.MAGNIFY);
	}
	
	/**
	 * 
	 */
	private void standardLoadCurrentFile() {
		Opener o = new Opener();
		o.open(this.currentFile.getAbsolutePath());
	}
	/**
	 * 
	 */
	public void browseForNewFolder() {
		JFileChooser fileChooser = new JFileChooser();
		if (OpenDialog.getDefaultDirectory()!=null) {
			fileChooser.setCurrentDirectory(new File(OpenDialog.getDefaultDirectory()));
		}
		fileChooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		fileChooser.setMultiSelectionEnabled(false);
		int returnVal = fileChooser.showOpenDialog(this.getView());
		if (returnVal != JFileChooser.APPROVE_OPTION) return;
		File newFolder = fileChooser.getSelectedFile();
		if (!newFolder.isDirectory()) {
			newFolder = fileChooser.getCurrentDirectory();
		}
		if (newFolder == null) return;
		this.setCurrentFolder(newFolder);
	}
	/**
	 * @return
	 */
	public SlideShowControlOptionsView getOptionsView() {
		if (optionsView == null) {
			optionsView = new SlideShowControlOptionsView(this);
		}
		this.changed("lookupTables");
		return optionsView;
	}
	/**
	 * @return Returns the lookupTables.
	 */
	public Vector getLookupTables() {
		return lookupTables;
	}
	/**
	 * @return Returns the lookupTable.
	 */
	public String getLookupTable() {
		return lookupTable;
	}
	/**
	 * @param lookupTable The lookupTable to set.
	 */
	public void setLookupTable(String lookupTable) {
		this.lookupTable = lookupTable;
	}
	/**
	 * @return Returns the adjustBrightness.
	 */
	public boolean isAdjustBrightness() {
		return adjustBrightness;
	}
	/**
	 * @param adjustBrightness The adjustBrightness to set.
	 */
	public void setAdjustBrightness(boolean adjustBrightness) {
		this.adjustBrightness = adjustBrightness;
	}
	/**
	 * @return Returns the auto.
	 */
	public boolean isAuto() {
		return auto;
	}
	/**
	 * @param auto The auto to set.
	 */
	public void setAuto(boolean auto) {
		this.auto = auto;
	}
	/**
	 * @return Returns the applyLookupTable.
	 */
	public boolean isApplyLookupTable() {
		return applyLookupTable;
	}
	/**
	 * @param applyLookupTable The applyLookupTable to set.
	 */
	public void setApplyLookupTable(boolean applyLookupTable) {
		this.applyLookupTable = applyLookupTable;
	}
	/**
	 * @return Returns the max.
	 */
	public int getMax() {
		return max;
	}
	/**
	 * @param max The max to set.
	 */
	public void setMax(int max) {
		this.max = max;
	}
	/**
	 * @return Returns the min.
	 */
	public int getMin() {
		return min;
	}
	/**
	 * @param min The min to set.
	 */
	public void setMin(int min) {
		this.min = min;
	}
	/**
	 * @param b
	 */
	public void setCloseAllImages(boolean b) {
		closeAllImages = b;
		
	}
	/**
	 * @param b
	 */
	public void setCloseLastImage(boolean b) {
		closeLastImage = b;
		
	}
	/**
	 * @return
	 */
	public boolean getCloseAllImages() {
		return closeAllImages;
	}
	/**
	 * @return
	 */
	public boolean getCloseLastImage() {
		return closeLastImage;
	}
	/**
	 * @return Returns the keepPosition.
	 */
	public boolean isKeepPosition() {
		return keepPosition;
	}
	/**
	 * @param keepPosition The keepPosition to set.
	 */
	public void setKeepPosition(boolean keepPosition) {
		this.keepPosition = keepPosition;
	}
}
