/*
 * Created on 20.07.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package operations;

import java.util.Vector;

import transforms.LineHoughTransform;
import gui.BooleanOption;
import gui.Option;
import gui.Options;
import ij.ImagePlus;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class LineHoughTransformOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = -3289575958884878665L;
	
	protected ImagePlus houghTransform;
	protected Vector resultLines;
	protected Option houghThreshold;
	protected BooleanOption showTransform;
	
	/**
	 * @throws ClassNotFoundException
	 *  
	 */
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";			
		optionsNames = new String[2];
		optionsNames[0] = "hough threshold";
		optionsNames[1] = "show transform";
		resultTypes = new Class[3];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultTypes[1] = Class.forName("java.util.Vector");
		resultTypes[2] = Class.forName("ij.ImagePlus");
		resultNames = new String[3];
		resultNames[0] = "Result";
		resultNames[1] = "ResultLines";
		resultNames[2] = "houghTransform";
	}
	/**
	 * @return Returns the houghTransform.
	 */
	public ImagePlus getHoughTransform() {
		return houghTransform;
	}
	
	public void doIt() {
		LineHoughTransform hough = new LineHoughTransform();
		hough.setInputImage(this.getInputImage());
		hough.run();
		this.houghTransform = hough.getAccumulatorImage();
		hough.computeLines(this.getHoughThreshold());
		result = hough.getLinesImage();
	}
	
	public double getHoughThreshold() {
		return houghThreshold.getDoubleValue();
	}
	
	public void setHoughThreshold(double threshold) {
		houghThreshold.setValue((new Double(threshold).toString()));
	}
	
	protected void setupOptions() {
		options = new Options(); 
		options.setName(this.name() + " options");
		String[] optionsNames = this.getOptionsNames();
		this.houghThreshold = new Option();
		this.setHoughThreshold(0.5);
		this.houghThreshold.setName(optionsNames[0]);
		options.add(this.houghThreshold);
		this.showTransform = new BooleanOption();
		showTransform.setName(optionsNames[1]);
		this.setShowTransform(false);
		options.add(showTransform);
	}
	
	public void connectOptions() {
		this.houghThreshold = (Option) this.options.getOptions().elementAt(0);
		this.showTransform = (BooleanOption) this.options.getOptions().elementAt(1);
	}
	/**
	 * @param b
	 */
	public void setShowTransform(boolean b) {
		showTransform.setValue((new Boolean(b)).toString());
	}

	public boolean getShowTransform() {
		return showTransform.getBooleanValue();
	}
	
	/**
	 * 
	 */
	protected void showResult() {
		if (this.getShowResult()) {
			this.getResult().show();
		}
		if (this.getShowTransform()) {
			this.getHoughTransform().show();
		}
	}
	
	/**
	 * @return Returns the resultLines.
	 */
	public Vector getResultLines() {
		return resultLines;
	}
}
