/*
 * Created on 23.06.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package operations;

import java.awt.geom.Line2D;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.IOException;
import java.io.Serializable;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.Observable;
import java.util.Vector;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import applications.Application;

import gui.ListEditor;
import gui.Option;
import gui.Options;
import help.HelpSystem;
import ij.IJ;
import ij.ImagePlus;
import ij.ImageStack;
import ij.WindowManager;
import ij.plugin.filter.Duplicater;
import ij.process.ImageProcessor;
import imagejProxies.MRIInterpreter;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Operation extends Observable implements Cloneable, Serializable, Runnable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -5729953658920751639L;
	protected Class[] parameterTypes;
	protected Class[] resultTypes;
	protected String[] parameterNames;
	protected String[] humanReadableParameterNames;
	protected String[] resultNames;
	protected String[] optionsNames;
	protected Vector inputMap;
	protected Options options;
	protected boolean keepSource;
	protected OperationView view;
	protected ImagePlus inputImage;
	protected ImagePlus result;
	static public Vector operationClasses;
	boolean showResult;
	protected String name;
	protected int progressMax;
	protected int progress;
	protected boolean isRunning;
	protected Thread task;
	protected Application application;
	protected MRIInterpreter interpreter;
	
	public Operation() {
		try {
			this.initialize();
			this.setupOptions();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	static public Vector operationClasses() {
		if (operationClasses == null) {
			setupOperationClasses();
		}
		return operationClasses;
		
	}
	
	/**
	 * @return Returns the humanReadableParameterNames.
	 */
	public String[] getHumanReadableParameterNames() {
		if (humanReadableParameterNames==null) {
			humanReadableParameterNames = new String[parameterNames.length];
			for (int i=0; i<parameterNames.length; i++) {
				humanReadableParameterNames[i] = Operation.humanReadableName(parameterNames[i]);
			}
		}
		return humanReadableParameterNames;
	}
	
	/**
	 * 
	 */
	private static void setupOperationClasses() {
		operationClasses = new Vector();
		class ClassComparator implements Comparator {

			/* (non-Javadoc)
			 * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
			 */
			public int compare(Object arg0, Object arg1) {
				String name1 = ((Class)arg0).getSimpleName();
				String name2 = ((Class)arg1).getSimpleName();
				return name1.compareTo(name2);
			}
			
		}
		try {
			operationClasses.add(Class.forName("controlOperations.AcceptOrSkipOrExitOperation"));
			operationClasses.add(Class.forName("processingOperations.AdaptiveErodeOperation"));
			operationClasses.add(Class.forName("processingOperations.AlignImagesOperation"));
			operationClasses.add(Class.forName("imageOperations.ApplyLutOperation"));
			operationClasses.add(Class.forName("segmentationOperations.ApplyRegionalThresholdsOperation"));
			operationClasses.add(Class.forName("stackOperation.AutoAlignImagesOperation"));
			operationClasses.add(Class.forName("stackOperation.AutoAlignSlicesOperation"));
			operationClasses.add(Class.forName("segmentationOperations.AutoThresholdOperation"));
			operationClasses.add(Class.forName("segmentationOperations.BinaryFillOperation"));
			operationClasses.add(Class.forName("stackRegistration.CalculateAlignmentTranslationsOperation"));
			operationClasses.add(Class.forName("imageOperations.ClearImageOperation"));
			operationClasses.add(Class.forName("roiOperations.ClearOperation"));
			operationClasses.add(Class.forName("fileOperations.CloseImageOperation"));
			operationClasses.add(Class.forName("controlOperations.CloseSessionOperation"));
			operationClasses.add(Class.forName("imageOperations.CombineImagesOperation"));
			operationClasses.add(Class.forName("analysisOperations.ComputeDifferenceOperation"));
			operationClasses.add(Class.forName("analysisOperations.ComputeMomentsOperation"));
			operationClasses.add(Class.forName("imageOperations.ConvertImageTypeOperation"));
			operationClasses.add(Class.forName("processingOperations.ConvolveOperation"));
			operationClasses.add(Class.forName("imageOperations.CopyImageOperation"));
			operationClasses.add(Class.forName("roiOperations.CropOperation"));
			operationClasses.add(Class.forName("operations.CutLinesToSizeOperation"));
			operationClasses.add(Class.forName("processingOperations.DilateOperation"));
			operationClasses.add(Class.forName("imageOperations.DrawCubeOperation"));
			operationClasses.add(Class.forName("imageOperations.DrawOperation"));
			operationClasses.add(Class.forName("stackOperation.DuplicateSliceOperation"));
			operationClasses.add(Class.forName("processingOperations.EnhanceContrastOperation"));
			operationClasses.add(Class.forName("processingOperations.EnhanceSpotsOperation"));
			operationClasses.add(Class.forName("segmentationOperations.EntropyThresholdOperation"));
			operationClasses.add(Class.forName("processingOperations.ErodeOperation"));
			operationClasses.add(Class.forName("processingOperations.FilterHorizontalLinesOperation"));
			operationClasses.add(Class.forName("analysisOperations.FilterLongObjectsOperation"));
			operationClasses.add(Class.forName("analysisOperations.FilterMeasurementsOperation"));
			operationClasses.add(Class.forName("imageOperations.FillImageOperation"));
			operationClasses.add(Class.forName("roiOperations.FillOperation"));
			operationClasses.add(Class.forName("analysisOperations.Find3dObjectsOperation"));
			operationClasses.add(Class.forName("processingOperations.FindAndSubtractBackgroundOperation"));
			operationClasses.add(Class.forName("processingOperations.FindEdgesOperation"));
			operationClasses.add(Class.forName("analysisOperations.FindEndsOperation"));
			operationClasses.add(Class.forName("analysisOperations.FindObjectsOperation"));
			operationClasses.add(Class.forName("analysisOperations.FindObjectsFloodFillOperation"));
			operationClasses.add(Class.forName("analysisOperations.FindObjectsRedirectingOperation"));
			operationClasses.add(Class.forName("operations.FindStraightLinesOperation"));
			operationClasses.add(Class.forName("controlOperations.ForeachImageDoOperation"));
			operationClasses.add(Class.forName("controlOperations.ForeachImageEndOperation"));
			operationClasses.add(Class.forName("controlOperations.ForeachImageInListDoOperation"));
			operationClasses.add(Class.forName("controlOperations.ForeachObjectDoOperation"));
			operationClasses.add(Class.forName("controlOperations.ForeachObjectEndOperation"));
			operationClasses.add(Class.forName("imageOperations.GammaAdjustOperation"));
			operationClasses.add(Class.forName("processingOperations.GaussianBlurOperation"));
			operationClasses.add(Class.forName("fileOperations.GetCurrentImageOperation"));	
			operationClasses.add(Class.forName("analysisOperations.GetImageFromHessianOperation"));
			operationClasses.add(Class.forName("controlOperations.GetImageListOperation"));
			operationClasses.add(Class.forName("controlOperations.GetImageNameOperation"));
			operationClasses.add(Class.forName("analysisOperations.GetVectorImageFromHessianOperation"));
			operationClasses.add(Class.forName("segmentationOperations.GreyscaleWatershedOperation"));
			operationClasses.add(Class.forName("processingOperations.GridMaximaOperation"));
			operationClasses.add(Class.forName("analysisOperations.HessianOperation"));
			operationClasses.add(Class.forName("fileOperations.HideImageOperation"));
			operationClasses.add(Class.forName("imageOperations.ImageCalculationOperation"));
			operationClasses.add(Class.forName("imageOperations.InvertImageOperation"));
			operationClasses.add(Class.forName("roiOperations.InverseSelectionOperation"));
			operationClasses.add(Class.forName("operations.LineHoughTransformOperation"));
			operationClasses.add(Class.forName("segmentationOperations.LocalThresholdOperation"));
			operationClasses.add(Class.forName("processingOperations.MaximumFilterOperation"));
			operationClasses.add(Class.forName("processingOperations.MeanFilterOperation"));
			operationClasses.add(Class.forName("segmentationOperations.MeanThresholdOperation"));
			operationClasses.add(Class.forName("analysisOperations.MeasureAllSlicesOperation"));		
			operationClasses.add(Class.forName("analysisOperations.MeasureOperation"));
			operationClasses.add(Class.forName("analysisOperations.MeasureMaskAreaOperation"));
			operationClasses.add(Class.forName("analysisOperations.MeasureMaxCubeOperation"));
			operationClasses.add(Class.forName("processingOperations.MedianFilterOperation"));
			operationClasses.add(Class.forName("segmentationOperations.MedianThresholdOperation"));
			operationClasses.add(Class.forName("channelOperations.MergeChannelsOperation"));
			operationClasses.add(Class.forName("processingOperations.MinimumFilterOperation"));
			operationClasses.add(Class.forName("controlOperations.NTimesRepeatEndOperation"));
			operationClasses.add(Class.forName("controlOperations.NTimesRepeatOperation"));
			operationClasses.add(Class.forName("roiOperations.ObjectsToPointSelectionOperation"));
			operationClasses.add(Class.forName("fileOperations.OpenImageOperation"));
			operationClasses.add(Class.forName("fileOperations.OpenSeriesAsStackOperation"));
			operationClasses.add(Class.forName("segmentationOperations.OtsuThresholdOperation"));
			operationClasses.add(Class.forName("stackOperation.RegisterSeriesSlicesOperation"));
			operationClasses.add(Class.forName("stackOperation.RegisterStackSlicesOperation"));
			operationClasses.add(Class.forName("roiOperations.RemoveSelectionOperation"));
			operationClasses.add(Class.forName("controlOperations.ReplaceNullWithEmptyImageOperation"));
			operationClasses.add(Class.forName("reportingOperations.ReportCalibratedAreaMeasurementOperation"));
			operationClasses.add(Class.forName("reportingOperations.ReportCountComparisonOperation"));
			operationClasses.add(Class.forName("reportingOperations.ReportIntensityClassesOperation"));
			operationClasses.add(Class.forName("reportingOperations.ReportIntensityComparisonOperation"));
			operationClasses.add(Class.forName("reportingOperations.ReportMeasurementsOperation"));
			operationClasses.add(Class.forName("reportingOperations.ReportObjectNumberRatioOperation"));
			operationClasses.add(Class.forName("reportingOperations.ReportPointMeasurementsOperation"));
			operationClasses.add(Class.forName("reportingOperations.ReportSegmentsOperation"));
			operationClasses.add(Class.forName("reportingOperations.ReportSpotsOnNucleiOperation"));
			operationClasses.add(Class.forName("reportingOperations.ReportStainCombinationsOperation"));
			operationClasses.add(Class.forName("reportingOperations.ReportTwoCountComparisonOperation"));	
			operationClasses.add(Class.forName("imageOperations.ResizeToRotateOperation"));
			operationClasses.add(Class.forName("fileOperations.SaveAsTiffSequenceOperation"));
			operationClasses.add(Class.forName("fileOperations.SaveImageOperation"));
			operationClasses.add(Class.forName("roiOperations.SaveSelectionOperation"));
			operationClasses.add(Class.forName("imageOperations.ScaleImageOperation"));
			operationClasses.add(Class.forName("operations.ScanForStraightLinesOperation"));
			operationClasses.add(Class.forName("segmentationOperations.SkeletonizeOperation"));
			operationClasses.add(Class.forName("roiOperations.SelectAllObjectsOperation"));
			operationClasses.add(Class.forName("roiOperations.SelectObjectOperation"));
			operationClasses.add(Class.forName("roiOperations.SelectWhitePixelOperation"));
			operationClasses.add(Class.forName("imageOperations.SetMinAndMaxDisplayOperation"));
			operationClasses.add(Class.forName("guiOperations.SetWindowPositionOperation"));
			operationClasses.add(Class.forName("fileOperations.ShowImageOperation"));
			operationClasses.add(Class.forName("fileOperations.ShowResultsTableOperation"));
			operationClasses.add(Class.forName("fileOperations.ShowTextOperation"));
			operationClasses.add(Class.forName("analysisOperations.ShortestPathsOperation"));
			operationClasses.add(Class.forName("controlOperations.SkipImageNotLoadedOperation"));
			operationClasses.add(Class.forName("controlOperations.SkipNoObjectsFoundOperation"));
			operationClasses.add(Class.forName("controlOperations.SkipSaturatedOperation"));
			operationClasses.add(Class.forName("analysisOperations.SplitAndCountOperation"));
			operationClasses.add(Class.forName("channelOperations.SplitChannelsOperation"));		
			operationClasses.add(Class.forName("imageOperations.SquareRootOperation"));
			operationClasses.add(Class.forName("processingOperations.SubtractBackgroundOperation"));
			operationClasses.add(Class.forName("processingOperations.SubstractMeanOperation"));
			operationClasses.add(Class.forName("processingOperations.SubtractBaselineOperation"));
			operationClasses.add(Class.forName("roiOperations.SubtractSelectionOperation"));
			operationClasses.add(Class.forName("segmentationOperations.ThresholdOperation"));
			operationClasses.add(Class.forName("analysisOperations.TraceLinesOperation"));			
			operationClasses.add(Class.forName("analysisOperations.TrackParticlesOperation"));
			operationClasses.add(Class.forName("roiOperations.TransferSelectionOperation"));
			operationClasses.add(Class.forName("processingOperations.TranslateImageOperation"));
			operationClasses.add(Class.forName("processingOperations.VarianceFilterOperation"));
			operationClasses.add(Class.forName("controlOperations.WaitForUserOperation"));
			operationClasses.add(Class.forName("segmentationOperations.WatershedOperation"));
			operationClasses.add(Class.forName("guiOperations.ZoomViewOperation"));
			operationClasses.add(Class.forName("stackOperation.ZProjectionOperation"));
			Collections.sort(operationClasses, new ClassComparator());
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * 
	 */
	protected void initialize() throws ClassNotFoundException {	
		keepSource = true;
		showResult = true;
	}
	
	/**
	 * 
	 */
	public void execute() {
		this.task = new Thread(this);
		task.start();
	}
	
	/**
	 * @param b
	 */
	protected void isRunning(boolean b) {
		isRunning = b;
		this.changed("isRunning");
	}

	/**
	 * 
	 */
	protected void doIt() {
		// TODO Auto-generated method stub
		
	}

	/**
	 * @return Returns the parameterTypes.
	 */
	public Class[] getParameterTypes() {
		return parameterTypes;
	}
	
	/**
	 * @param parameterTypes The parameterTypes to set.
	 */
	public void setParameterTypes(Class[] parameterTypes) {
		this.parameterTypes = parameterTypes;
	}
	
	/**
	 * @return Returns the resultType.
	 */
	public Class[] getResultTypes() {
		return resultTypes;
	}
	
	/**
	 * @param resultType The resultType to set.
	 */
	public void setResultTypes(Class[] resultType) {
		this.resultTypes = resultType;
	}
	
	public int getNumberOfParameter() {
		return parameterTypes.length;
	}
	
	public int getNumberOfResults() {
		return resultTypes.length;
	}
	/**
	 * @return Returns the parameterNames.
	 */
	public String[] getParameterNames() {
		return parameterNames;
	}
	/**
	 * @param parameterNames The parameterNames to set.
	 */
	public void setParameterNames(String[] parameterNames) {
		this.parameterNames = parameterNames;
	}
	/**
	 * @return Returns the resultNames.
	 */
	public String[] getResultNames() {
		return resultNames;
	}
	/**
	 * @param resultNames The resultNames to set.
	 */
	public void setResultNames(String[] resultNames) {
		this.resultNames = resultNames;
	}
	/**
	 * @return Returns the keepSource.
	 */
	public boolean isKeepSource() {
		return keepSource;
	}
	/**
	 * @param keepSource The keepSource to set.
	 */
	public void setKeepSource(boolean keepSource) {
		this.keepSource = keepSource;
	}

	/**
	 * @return Returns the inputImage.
	 */
	public ImagePlus getInputImage() {
		if (inputImage==null) {
			inputImage = WindowManager.getCurrentImage();
		}
		return inputImage;
	}

	/**
	 * @param inputImage The inputImage to set.
	 */
	public void setInputImage(ImagePlus inputImage) {
		this.inputImage = inputImage;
	}

	/**
	 * @return Returns the result.
	 */
	public ImagePlus getResult() {
		return result;
	}

	public void setResult(ImagePlus anImage) {
		result = anImage;
	}
	
	public void show() {
		this.view().setVisible(true);
	}

	/**
	 * @return
	 */
	public OperationView view() {
		if (this.view == null) {
			this.view = new OperationView(this);
		}
		return this.view;
	}

	public String name() {
		if (name==null) {	
			name = this.getClass().getSimpleName();
			int index = name.lastIndexOf("Operation");
			name = name.substring(0, index);
			name = humanReadableName(name);
		}
		return name;
	}
	
	public void setName(String name) {
		this.name = name; 
	}

	/**
	 * @param name
	 * @return
	 */
	public static String humanReadableName(String name) {
		char[] chars = name.toCharArray();
		String result = "";
		for (int i=0; i<chars.length; i++) {
			char current = chars[i];
			if (i>0 && Character.isUpperCase(current) || Character.isDigit(current)) {
				result = result + " ";
			}
			result = result + Character.toString(Character.toLowerCase(current));
		}
		return result;
	}

	/**
	 * @return
	 */
	public Vector categories() {
		Vector categories = new Vector();
		return categories;
	}
	
	public Object clone() {
		Operation clone = null;
		try {
			clone = (Operation) this.getClass().newInstance();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return clone;
	}
	/**
	 * @return Returns the showResult.
	 */
	public boolean getShowResult() {
		return showResult;
	}
	/**
	 * @param showResult The showResult to set.
	 */
	public void setShowResult(boolean showResult) {
		this.showResult = showResult;
	}
	/**
	 * @return Returns the optionsNames.
	 */
	public String[] getOptionsNames() {
		if (optionsNames == null) optionsNames = new String[0];
		return optionsNames;
	}
	/**
	 * @param optionsNames The optionsNames to set.
	 */
	public void setOptionsNames(String[] optionsNames) {
		this.optionsNames = optionsNames;
	}
	
	/**
	 * @return Returns the options.
	 */
	public Options getOptions() {
		return options;
	}
	/**
	 * 
	 */
	protected void setupOptions() {
		options = new Options(); 
		options.setName(this.name() + " options");
		String[] optionsNames = this.getOptionsNames();
		for (int i=0; i<optionsNames.length; i++) {
			Option option = new Option();
			option.setName(optionsNames[i]);
			options.add(option);
		}
		this.connectOptions();
	}

	/**
	 * @return
	 */
	public boolean isApplication() {
		// TODO Auto-generated method stub
		return false;
	}
	
	public void showApplicationView() {
		// Do nothing
		// overwritten in Application
	}
	/**
	 * @return Returns the inputMap.
	 */
	public Vector getInputMap() {
		if (inputMap==null) {
			inputMap = new Vector();
			for (int i=0; i<this.getNumberOfParameter();i++) {
				int[] map = new int[2];
				map[0] = -1;
				map[1] = -1;
				inputMap.add(map);
			}
		}
		return inputMap;
	}
	
	public void resetInputMap() {
		inputMap = null;
		this.changed("input map");
	}
	
	public int[] getInputMapForParameter(int i) {
		return (int[])this.getInputMap().elementAt(i);
	}
	
	public void setInputForParameterTo(int parameter, int operation, int result) {
		int[] map =(int[])this.getInputMap().elementAt(parameter);
		map[0] = operation;
		map[1] = result;
		this.changed("input map");
	}

	public void printOn(BufferedWriter out) throws IOException {
		out.write(this.getClass().getName() + "\n");
		String parameterAddition = "";
		if (!this.isKeepSource()) parameterAddition = "/keepSource=false";
		out.write(this.name() + parameterAddition +  "\n");
		this.options.printOn(out);
		Iterator it = this.getInputMap().iterator();
		while (it.hasNext()) {
			int[] anInputMap = (int[])it.next();
			out.write(anInputMap[0] + "," + anInputMap[1] + "\n");
		}
		out.write("[end input maps]\n");
	}
	
	public static Operation readFrom(BufferedReader in) throws IOException {
		IOException error = new IOException();
		String className = in.readLine();
		if (className==null) {
			return null;
		}
		Operation operation = null;
		try {
			operation = (Operation)Class.forName(className).newInstance();
			operation.setShowResult(false);
			operation.setupFrom(in);
			operation.connectOptions();
		} catch (InstantiationException e) {
			error.setStackTrace(e.getStackTrace());
			throw error;
		} catch (IllegalAccessException e) {
			error.setStackTrace(e.getStackTrace());
			throw error;
		} catch (ClassNotFoundException e) {
			error.setStackTrace(e.getStackTrace());
			throw error;
		}
		return operation;
	}

	/**
	 * 
	 */
	public void connectOptions() {
	}
	
	/**
	 * @param in
	 * @throws IOException
	 */
	public void setupFrom(BufferedReader in) throws IOException {
		String operationName = in.readLine();
		String[] data = operationName.split("/");
		if (data.length>1 && data[1].equals("keepSource=false")) this.setKeepSource(false);
		this.setName(data[0]);
		this.options = new Options();
		options.setupFrom(in);
		String line = null;
		this.inputMap = new Vector();
		while((line = in.readLine())!=null) {
			if (line.equals("[end input maps]")) {
				break;
			} 
			data = line.split(",");
			int[] anInputMap = new int[2];
			anInputMap[0] = Integer.parseInt(data[0]);
			anInputMap[1] = Integer.parseInt(data[1]);
			inputMap.add(anInputMap);
		}
	}

	/**
	 * @return
	 */
	public String getFilename() {
		// TODO Auto-generated method stub
		return null;
	}
	
	public void changed(String anAspect) {
		this.setChanged();
		this.notifyObservers(anAspect);
	}

	/**
	 * @return
	 */
	public boolean isConnected() {
		boolean result = true;
		if (this.numberOfParameters()==0) return result;
		Iterator it = this.getInputMap().iterator();
		while (it.hasNext()) {
			int[] aMap = (int[])it.next();
			if (aMap[0]==-1 || aMap[1]==-1) result = false;
		}
		return result;
	}

	/**
	 * @return
	 */
	private int numberOfParameters() {
		return this.getParameterNames().length;
	}
	/**
	 * @return Returns the progress.
	 */
	public int getProgress() {
		return progress;
	}
	/**
	 * @param progress The progress to set.
	 */
	public void setProgress(int progress) {
		this.progress = progress;
		this.changed("progress");
	}
	/**
	 * @return Returns the progressMax.
	 */
	public int getProgressMax() {
		return progressMax;
	}
	/**
	 * @param progressMax The progressMax to set.
	 */
	public void setProgressMax(int progressMax) {
		this.progressMax = progressMax;
		this.changed("progressMax");
	}

	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		try {
			this.isRunning(true);
			if (this.isBatchOperation()) {
				this.getInterpreter().setBatchMode(true);
			}
			this.doIt();
			if (this.getShowResult()) {
				showResult();
			}
		} catch (Exception e) {
			String message = "An error occured in " + this.name() + "\n";
			if (e.getMessage()!=null) message = message + e.getMessage();
			JOptionPane.showConfirmDialog(this.view(), message,
					"operation error", JOptionPane.CLOSED_OPTION);
			e.printStackTrace();
			this.stopApplication();
		} finally {
			cleanUpInput();
			System.gc();
			this.isRunning(false);
			this.getInterpreter().setBatchMode(false);
		}
	}
	/**
	 * 
	 */
	protected void cleanUpInput() {
		this.setInputImage(null);
	}

	/**
	 * 
	 */
	protected void showResult() {
		if (this.getResult()==null) return;
		this.getResult().show();
	}

	/**
	 * @return Returns the task.
	 */
	public Thread getTask() {
		return task;
	}

	/**
	 * 
	 */
	public void openHelp() {
		HelpSystem help = HelpSystem.getCurrent();
		help.openHelpFor(this.name());
	}
	
	/**
	 * 
	 */
	static public void drawLines(Vector lines, ImageProcessor ip) {
		for (int i=0; i<lines.size();i++) {
			Line2D aLine = (Line2D) lines.elementAt(i);
			ip.drawLine((int)Math.round(aLine.getX1()), 
										   (int)Math.round(aLine.getY1()), 
										   (int)Math.round(aLine.getX2()), 
										   (int)Math.round(aLine.getY2()));
		}
		
	}

	/**
	 * @param inputMap
	 */
	public void setInputMap(Vector inputMap) {
		this.inputMap = inputMap;
	}

	/**
	 * @param application
	 */
	public void setApplication(Application application) {
		this.application = application;
		
	}
	
	/**
	 * @return Returns the application.
	 */
	public Application getApplication() {
		return application;
	}

	/**
	 * @return
	 */
	public boolean isLoop() {
		// TODO Auto-generated method stub
		return false;
	}

	/**
	 * @return
	 */
	public Operation getEndLoopOperation() {
		// TODO Auto-generated method stub
		return null;
	}
	
	
	public boolean isLoopEnd() {
		return false;
	}
	
	public void stopApplication() {
		if (this.application!=null) {
			this.application.stop();
		}
	}
	
	public int browseFileForOption(Option anOption) {
		JFileChooser fileChooser = new JFileChooser();
		if (IJ.getDirectory("image")!=null) {
			fileChooser.setCurrentDirectory(new File(IJ.getDirectory("image")));
		}
		fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		fileChooser.setMultiSelectionEnabled(false);
		fileChooser.addChoosableFileFilter(ListEditor.getImageFileFilter());
		fileChooser.addChoosableFileFilter(ListEditor.getTiffFileFilter());
		int returnVal = fileChooser.showOpenDialog(null);
		if (returnVal != JFileChooser.APPROVE_OPTION) return -1;
		anOption.setValue(fileChooser.getSelectedFile().getAbsolutePath());
		return returnVal;
	}

	/**
	 * 
	 */
	public void resetPathOptions() {
		// by default do nothing, overwrite if action needed.
		
	}
	
	public void setPathOptionsFromUser() {
		// by default do nothing, overwrite if action needed.
	}

	/**
	 * 
	 */
	public void reset() {
		// TODO Auto-generated method stub
		
	}
	
	public int getCurrentIndex() {
		return -1;
	}

	protected void doItForSlice(int sliceNumber, ImageStack stack) {
	}
	/**
	 * 
	 */
	protected void processSlices() {
		ImageStack stack = result.getStack();
		for (int i=1; i<=result.getStackSize(); i++) {
			IJ.showStatus("processing slice " + i + " of " + result.getStackSize());
			this.doItForSlice(i, stack);
			Thread.yield();
		}
		result.setStack(inputImage.getTitle() + " - " + this.name(), stack);
	}
	
	protected boolean isBatchOperation() {
		return !this.getShowResult();
	}
	
	public MRIInterpreter getInterpreter() {
		if (interpreter==null) {
			interpreter = new MRIInterpreter();
		}
		return interpreter;
	}

	protected ImagePlus getCopyOfOrReferenceTo(ImagePlus inputImage, String title) {
		ImagePlus result = inputImage;
		if (keepSource) {
			result = this.copyImage(inputImage, title);
		}
		return result;
	}
	
	protected ImagePlus copyImage(ImagePlus anImage, String title) {
		ImagePlus result = null;
		Duplicater copyAction = new Duplicater();
		result = copyAction.duplicateStack(anImage, title);
		if (result.getNSlices()==1) result.setImage(result.getProcessor().createImage());
		return result;
	}

	public boolean isRunning() {
		return isRunning;
	}
}
