/*
 * Created on 02.11.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package processingOperations;

import ij.ImagePlus;
import imagejProxies.SilentContrastEnhancer;
import gui.BooleanOption;
import gui.Option;
import gui.Options;
import operations.Operation;

/**
 * @author Volker
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class EnhanceContrastOperation extends Operation {
	/**
	 * 
	 */
	private static final long serialVersionUID = -6351286066408777162L;

	protected SilentContrastEnhancer contrastEnhancer;	
	
	protected Option percentSaturated;
	protected BooleanOption equalize;
	protected BooleanOption normalize;
	protected BooleanOption useStackHistogram;
	
	protected void initialize() throws ClassNotFoundException {
		super.initialize();
		optionsNames = new String[4];
		optionsNames[0] = "percent saturated";
		optionsNames[1] = "equalize";
		optionsNames[2] = "normalize";
		optionsNames[3] = "use stack histogram";
		parameterTypes = new Class[1];
		parameterTypes[0] = Class.forName("ij.ImagePlus");
		parameterNames = new String[1];
		parameterNames[0] = "InputImage";
		resultTypes = new Class[1];
		resultTypes[0] = Class.forName("ij.ImagePlus");
		resultNames = new String[1];
		resultNames[0] = "Result";
	}
	
	public void doIt() {
		ImagePlus inputImage = this.getInputImage();
		this.contrastEnhancer = null;
		result = this.getCopyOfOrReferenceTo(inputImage, inputImage.getTitle());
		this.getContrastEnhancer().run("");
	}
	
	protected void setupOptions() {
		options = new Options(); 
		options.setName(this.name() + " options");
		String[] optionsNames = this.getOptionsNames();
		
		this.percentSaturated = new Option();
		this.setPercentSaturated(0.5f);
		this.percentSaturated.setName(optionsNames[0]);
		options.add(percentSaturated);
		
		this.equalize = new BooleanOption();
		this.setEqualize(false);
		this.equalize.setName(optionsNames[1]);
		options.add(equalize);
		
		this.normalize = new BooleanOption();
		this.setNormalize(true);
		this.normalize.setName(optionsNames[2]);
		options.add(normalize);
		
		this.useStackHistogram = new BooleanOption();
		this.setUseStackHistogram(false);
		this.useStackHistogram.setName(optionsNames[3]);
		options.add(useStackHistogram);
	}
	
	public void connectOptions() {
		percentSaturated = (Option)options.getOptions().elementAt(0);
		equalize = (BooleanOption)options.getOptions().elementAt(1);
		normalize = (BooleanOption)options.getOptions().elementAt(2);
		useStackHistogram = (BooleanOption)options.getOptions().elementAt(3);
	}
	
	/**
	 * @return Returns the equalize.
	 */
	public boolean getEqualize() {
		return equalize.getBooleanValue();
	}
	/**
	 * @param equalize The equalize to set.
	 */
	public void setEqualize(boolean equalize) {
		this.equalize.setValue(Boolean.toString(equalize));
	}
	/**
	 * @return Returns the normalize.
	 */
	public boolean getNormalize() {
		return normalize.getBooleanValue();
	}
	/**
	 * @param normalize The normalize to set.
	 */
	public void setNormalize(boolean normalize) {
		this.normalize.setValue(Boolean.toString(normalize));
	}
	/**
	 * @return Returns the percentSaturated.
	 */
	public float getPercentSaturated() {
		return percentSaturated.getFloatValue();
	}
	/**
	 * @param percentSaturated The percentSaturated to set.
	 */
	public void setPercentSaturated(float percentSaturated) {
		this.percentSaturated.setValue(Float.toString(percentSaturated));
	}
	/**
	 * @return Returns the useStackHistogram.
	 */
	public boolean getUseStackHistogram() {
		return useStackHistogram.getBooleanValue();
	}
	/**
	 * @param useStackHistogram The useStackHistogram to set.
	 */
	public void setUseStackHistogram(boolean useStackHistogram) {
		this.useStackHistogram.setValue(Boolean.toString(useStackHistogram));
	}
	/**
	 * @return Returns the contrastEnhancer.
	 */
	public SilentContrastEnhancer getContrastEnhancer() {
		contrastEnhancer = new SilentContrastEnhancer(this.result);
		contrastEnhancer.setProcessStack(true);
		contrastEnhancer.setPercentSaturated(this.getPercentSaturated());
		contrastEnhancer.setEqualize(this.getEqualize());
		contrastEnhancer.setNormalize(this.getNormalize());
		contrastEnhancer.useStackHistogram(this.getUseStackHistogram());
		return contrastEnhancer;
	}
}
