package stackRegistration;

import gui.ProgressBar;

import java.awt.Rectangle;
import java.io.File;
import java.util.Iterator;
import java.util.Vector;

import applications.Application;

public class TreatAndSaveSlices implements Runnable {

	protected Rectangle zeroAndImageSize;
	protected File targetFile;
	protected Vector translations;
	protected Thread task;
	protected Application application;
	protected boolean showProgress;
	protected ProgressBar progress;
	protected boolean applyTranslations;

	public TreatAndSaveSlices(Vector translations, File targetFile, Rectangle zeroAndImageSize, Application app, boolean applyTranslations) {
		this.translations = translations;
		this.targetFile = targetFile;
		this.zeroAndImageSize = zeroAndImageSize;
		this.application = app;
		this.applyTranslations = applyTranslations;
	}

	public void run() {
		Iterator it = translations.iterator();
		while(it.hasNext()) {
			AlignmentSlice currentTranslation = (AlignmentSlice)it.next();
			currentTranslation.setApplication(this.application);
			currentTranslation.saveWithSize(targetFile, zeroAndImageSize, applyTranslations);
			if (isShowProgress()) progress.setProgress(progress.getProgress() + 1);
			Thread.yield();
		}
	}
			
	public void execute() { 
		if (this.isShowProgress()) {
			progress = new ProgressBar(0, translations.size()-1, "treating slices");
			progress.setCloseWhenFinished(true);
			progress.getView().setVisible(true);
		}
		this.task = new Thread(this);
		task.start();
	}

	public boolean isShowProgress() {
		return showProgress;
	}

	public void setShowProgress(boolean showProgress) {
		this.showProgress = showProgress;
	}

}
